
local colors = SPTimers.CustomColors

local procs = { -- short timed buffs, trinkets etc

	-- caster trinckets 
	[125487] = {}, -- LIGHTWELL
	[125488] = {}, -- Darkglow
	[125489] = {}, -- Swordguard Embroidery	
	
	[104993] = { source = 1, several = true }, -- JADE SPIRIT
	[120032] = { source = 1, several = true }, -- 
	[118335] = { source = 1, several = true },
	[96230]  = {}, -- SYNAPSE SPRINGS
	[96229]  = {}, -- SYNAPSE SPRINGS
	[96228]  = {}, -- SYNAPSE SPRINGS

	[138898] = {}, -- MEGAERA
	[138963] = {}, -- UVLS
	[139133] = {}, -- CHAE
	[138786] = { checkstaucks = 138788 }, -- WYSHU
	[137590] = {}, -- LMG
	[128985] = {}, -- Relic of Yu'lon
	
	[138703] = {}, -- 5.2 Spell Valor trinket
	[138699] = {},
	
	[146046] = {}, -- immerseus Trincket	
	[146184] = {checkstaucks = 146202 }, -- Garrosh trinket
	[146218] = {}, -- Celestial trinket +crit
	[148906] = {}, -- KorKronShaman
	[148897] = {}, -- Malkorok

	[33702] = {},
	[33697] = {},
	[20572] = {},
	
	-- Potions
	[105702] ={}, -- Potion of the Jade Serpent
	
	----- Hero --------
	[90355] = { source = 1 },
	[2825] = { source = 1 },
	[32182] = { source = 1 },
	[80353] = { source = 1 },
	[146555] = { source = 1},
	-------------------
	
	-- Melee trinkets 
	
	[146308] = {},
	[148903] = {},
	[146310] = {},
	[148896] = {},
	
	[148899] = {},
	[146245] = {},
	[146285] = {},
	[146250] = {},
	
	[146312] = {},
	[126649] = {},
	
	[146296] = {},
	-- Tanks trinkers
	
	[105645] = {},
	[146343] = {},
	[146344] = {},
	
	-- Healers
	
	[146317] = {},
	[146314] = {},
	[148911] = {},
	[148908] = {},
	------------------------------
}

local internal_cooldowns = {
	[GetSpellInfo(125487)] = { spellid = 125487, icd = 60, },
	[GetSpellInfo(125488)] = { spellid = 125488, icd = 60, },
	[GetSpellInfo(125489)] = { spellid = 125489, icd = 60, },

	[GetSpellInfo(146046)] = { spellid = 146046, icd = 115, },
	[GetSpellInfo(146308)] = { spellid = 146308, icd = 115, },
	[GetSpellInfo(148896)] = { spellid = 148896, icd = 85,  },
	[GetSpellInfo(148897)] = { spellid = 148897, icd = 85,  },
	
	[GetSpellInfo(146312)] = { spellid = 146312, icd = 115,  },
	[GetSpellInfo(126649)] = { spellid = 126649, icd = 115,  },
	[GetSpellInfo(146218)] = { spellid = 146218, icd = 115,  },
	[GetSpellInfo(146296)] = { spellid = 146296, icd = 115,  },

	[GetSpellInfo(148899)] = { spellid = 148899, checkID = true, icd = 85,  },
	[GetSpellInfo(146245)] = { spellid = 146245, icd = 55,  },
	[GetSpellInfo(146250)] = { spellid = 146250, icd = 55,  },
	
	[GetSpellInfo(146314)] = { spellid = 146314, icd = 115,  },
	[GetSpellInfo(148911)] = { spellid = 148911, icd = 115,  },

	[GetSpellInfo(96230)] = { spellid = 96230, icd = 60, },
	[GetSpellInfo(96229)] = { spellid = 96229, icd = 60, },
	[GetSpellInfo(96228)] = { spellid = 96228, icd = 60, },

}


local others = {
	[95223] = { blacklist = 4, blacklist_cleu = 4 },
	[1490] =	{ target = 1, priority = -21 },
	[119653] =  { target = 1, priority = -21 },
	[81328] =	{ target = 1, priority = -21 },
	[113746] =	{ target = 1, priority = -21 },
	[115798] =	{ target = 1, priority = -21 },
	[93068] = 	{ target = 1, priority = -21 },
	
	[114206] = { source = 1, color = colors.GOLD, group = "player", },
	[31821] = { source = 1, duration = 6, color = colors.GOLD, group = "procs"},
}

local customGroups = {}

do
	local anchor_unit = { "focus", "boss1","boss2","boss3","boss4","boss5", "arena1","arena2","arena3","arena4","arena5", "mouseover"}
	local unit_list = { "target", "focus", "boss1","boss2","boss3","boss4","boss5", "arena1","arena2","arena3","arena4","arena5" }
	local unit_list2 = { "target", "focus", "boss1","boss2","boss3","boss4","boss5", "arena1","arena2","arena3","arena4","arena5", "mouseover"}
	
	local UnitGUID = UnitGUID
	function SPTimers:FindUnitGUID(destGUID)
		for k,v in ipairs(anchor_unit) do
			if UnitGUID(v) == destGUID then return v end
		end
		return nil
	end
	
	function SPTimers:FindUnitGUID_SMO(destGUID)
		for k,v in ipairs(unit_list) do
			if UnitGUID(v) == destGUID then return v end
		end
		return nil
	end
	
	function SPTimers:FindUnitUnit(unit)
		for k,v in ipairs(unit_list2) do
			if UnitIsUnit(v, unit) and unti ~= v then return v end
		end
		return nil
	end
end

function SPTimers:GetUnitAnchor(spellID, destGUID)
	
		if self.db.profile.classSpells[self.myCLASS][spellID].anchor_per_unit_enabled and destGUID then
			local unit = self:FindUnitGUID(destGUID)
			
			if unit == "target" and self.db.profile.classSpells[self.myCLASS][spellID].set_anchor then
				return self.db.profile.bars_anchors[self.db.profile.classSpells[self.myCLASS][spellID].set_anchor] and self.db.profile.classSpells[self.myCLASS][spellID].set_anchor or 1			
			end
			
			if unit and 
				self.db.profile.classSpells[self.myCLASS][spellID].anchor_per_unit[unit] and 
				self.db.profile.classSpells[self.myCLASS][spellID].anchor_per_unit[unit] ~= 0 and
				self.db.profile.bars_anchors[self.db.profile.classSpells[self.myCLASS][spellID].anchor_per_unit[unit]] then
						
		--		print("SPTimers:GetUnitAnchor", unit,  self.db.profile.classSpells[self.myCLASS][spellID].anchor_per_unit[unit])
						
				return self.db.profile.classSpells[self.myCLASS][spellID].anchor_per_unit[unit]
			end
		end
	return nil
end

function SPTimers:GetAnchor(spellID, destGUID)

	if self.db.profile.classSpells[self.myCLASS][spellID] then
			
		if not self.db.profile.doswap then
			
			local unit_a = SPTimers:GetUnitAnchor(spellID, destGUID)
			
			if unit_a then 
				return unit_a 
			else
				if self.db.profile.classSpells[self.myCLASS][spellID].set_anchor then			
					return self.db.profile.bars_anchors[self.db.profile.classSpells[self.myCLASS][spellID].set_anchor] and self.db.profile.classSpells[self.myCLASS][spellID].set_anchor or 1 
				end
			end
				
		elseif self.db.profile.classSpells[self.myCLASS][spellID].set_anchor then 		
			return self.db.profile.bars_anchors[self.db.profile.classSpells[self.myCLASS][spellID].set_anchor] and self.db.profile.classSpells[self.myCLASS][spellID].set_anchor or 1 
		end
	end
		
	if self.db.profile.procSpells[spellID]
		and self.db.profile.procSpells[spellID].set_anchor then
	return self.db.profile.bars_anchors[self.db.profile.procSpells[spellID].set_anchor] and self.db.profile.procSpells[spellID].set_anchor or 1 end
	
	if self.db.profile.othersSpells[spellID] 
		and self.db.profile.othersSpells[spellID].set_anchor then 
	return self.db.profile.bars_anchors[self.db.profile.othersSpells[spellID].set_anchor] and self.db.profile.othersSpells[spellID].set_anchor or 1 end
	
	if self.db.profile.totems[spellID] and self.db.profile.totems[spellID].anchor then
		return self.db.profile.totems[spellID].anchor
	end
	
	if self.db.profile.enchants[spellID] and self.db.profile.enchants[spellID].anchor then
		return self.db.profile.enchants[spellID].anchor
	end
	
	return 1
end

function SPTimers:DoUnitAnchor(spellID)
	if self.db.profile.classSpells[self.myCLASS][spellID] then
		return self.db.profile.classSpells[self.myCLASS][spellID].anchor_per_unit_enabled
	end
end

function SPTimers:GetOffAnchor(spellID, destGUID)
	
	if self.db.profile.doswap then
		if self.db.profile.classSpells[self.myCLASS][spellID] then
			
			local unit_a = SPTimers:GetUnitAnchor(spellID, destGUID)
			
			if unit_a then
				return unit_a
			elseif self.db.profile.classSpells[self.myCLASS][spellID].offtarge then 		
				return self.db.profile.bars_anchors[self.db.profile.classSpells[self.myCLASS][spellID].offtarge] and self.db.profile.classSpells[self.myCLASS][spellID].offtarge or 1
			end
		
		end
		
		if self.db.profile.procSpells[spellID]
			and self.db.profile.procSpells[spellID].offtarge then
		return self.db.profile.bars_anchors[self.db.profile.procSpells[spellID].offtarge] and self.db.profile.procSpells[spellID].offtarge or 1 end
		
		if self.db.profile.othersSpells[spellID] 
			and self.db.profile.othersSpells[spellID].offtarge then 
		return self.db.profile.bars_anchors[self.db.profile.othersSpells[spellID].offtarge] and self.db.profile.othersSpells[spellID].offtarge or 1 end
	end
	
	return self:GetAnchor(spellID, destGUID) or 1
end

function SPTimers:GetGroup(spellID)
	if self.db.profile.classSpells[self.myCLASS][spellID] and self.db.profile.classSpells[self.myCLASS][spellID].group ~= "auto" then
		return self.db.profile.classSpells[self.myCLASS][spellID].group 
	end
	if self.db.profile.procSpells[spellID] and self.db.profile.procSpells[spellID].group ~= "auto" then 
		return self.db.profile.procSpells[spellID].group 
	end
	if self.db.profile.othersSpells[spellID] and self.db.profile.othersSpells[spellID].group ~= "auto" then
		return self.db.profile.othersSpells[spellID].group 
	end
	
	if self.db.profile.totems[spellID] and self.db.profile.totems[spellID].group ~= "auto" then
		return self.db.profile.totems[spellID].group
	end
	
	if self.db.profile.enchants[spellID] and self.db.profile.enchants[spellID].group ~= "auto" then
		return self.db.profile.enchants[spellID].group
	end
	
	return nil
end


function SPTimers:GetCheckStacks(spellID)
	if self.db.profile.procSpells[spellID] and 
	   self.db.profile.procSpells[spellID].checkstaucks_on then
	   local spellname = GetSpellInfo(self.db.profile.procSpells[spellID].checkstaucks)
	   
		if spellname then
			local name, _, _, count, _, _, _, _, _, _, ua_spellid = UnitBuff("player", spellname)

			if name and name == spellname then				
				return count 
			end
		end
	end
	return nil
end

function SPTimers:GetPriority(spellID)
	if self.db.profile.classSpells[self.myCLASS][spellID] then
		if self.db.profile.classSpells[self.myCLASS][spellID].priority and type(self.db.profile.classSpells[self.myCLASS][spellID].priority) == "number" then
			return self.db.profile.classSpells[self.myCLASS][spellID].priority
		end
	end
	if self.db.profile.procSpells[spellID] then
		if self.db.profile.procSpells[spellID].priority and type(self.db.profile.procSpells[spellID].priority) == "number" then
			return self.db.profile.procSpells[spellID].priority 
		end
	end
	if self.db.profile.othersSpells[spellID] then
		if self.db.profile.othersSpells[spellID].priority and type(self.db.profile.othersSpells[spellID].priority) == "number" then
			return self.db.profile.othersSpells[spellID].priority 
		end
	end
	
	if self.db.profile.totems[spellID] then
		if self.db.profile.totems[spellID].priority and type(self.db.profile.totems[spellID].priority) == "number" then
			return self.db.profile.totems[spellID].priority
		end
	end
	
	if self.db.profile.enchants[spellID] then
		if self.db.profile.enchants[spellID].priority and type(self.db.profile.enchants[spellID].priority) == "number" then
			return self.db.profile.enchants[spellID].priority
		end
	end
	
	return 0
end

function SPTimers:GetTargetType(spellID)
	if self.db.profile.classSpells[self.myCLASS][spellID] then
		if self.db.profile.classSpells[self.myCLASS][spellID].target then
			return self.db.profile.classSpells[self.myCLASS][spellID].target
		end
	end
	if self.db.profile.procSpells[spellID] then
		if self.db.profile.procSpells[spellID].target then
			return self.db.profile.procSpells[spellID].target 
		end
	end
	if self.db.profile.othersSpells[spellID] then
		if self.db.profile.othersSpells[spellID].target then
			return self.db.profile.othersSpells[spellID].target 
		end
	end

	return 3
end



function SPTimers:GetColor(spellID)
	if self.db.profile.classSpells[self.myCLASS][spellID] then
		if self.db.profile.classSpells[self.myCLASS][spellID].color_on or self.db.profile.classSpells[self.myCLASS][spellID].color_on == nil then
			return self.db.profile.classSpells[self.myCLASS][spellID].color
		end
	end
	if self.db.profile.procSpells[spellID] then
		if self.db.profile.procSpells[spellID].color_on or self.db.profile.procSpells[spellID].color_on == nil then
			return self.db.profile.procSpells[spellID].color 
		end
	end
	if self.db.profile.othersSpells[spellID] then
		if self.db.profile.othersSpells[spellID].color_on or self.db.profile.othersSpells[spellID].color_on == nil then
			return self.db.profile.othersSpells[spellID].color 
		end
	end
	
	if self.db.profile.totems[spellID] then
		return self.db.profile.totems[spellID].color
	end
	
	if self.db.profile.enchants[spellID] then
		return self.db.profile.enchants[spellID].color
	end
	
	return nil
end

function SPTimers:ShowTotems(totem)
	if self.db.profile.totems[totem] then
		return self.db.profile.totems[totem].show
	end
end

function SPTimers:IsSeveralAuras(spellID)
	if self.db.profile.classSpells[self.myCLASS][spellID] then
		if self.db.profile.classSpells[self.myCLASS][spellID].several then
			return true
		end
	end
	if self.db.profile.procSpells[spellID] then
		if self.db.profile.procSpells[spellID].several then
			return true
		end
	end
	if self.db.profile.othersSpells[spellID] then
		if self.db.profile.othersSpells[spellID].several then
			return true
		end
	end

	return false
end

function SPTimers:GetCooldown(spellName)
	if self.db.profile.classCooldowns[self.myCLASS][spellName] then	
		return self.db.profile.classCooldowns[self.myCLASS][spellName].hide
	end
	if self.db.profile.internal_cooldowns[spellName] then	
		return self.db.profile.internal_cooldowns[spellName].hide
	end
	
	if self.db.profile.cooldownline.block[spellName] then 
		return self.db.profile.cooldownline.block[spellName].hide
	end
	
	return nil
end

function SPTimers:DoBigSplashCooldown(spellName)

	local force = self.db.profile.cooldownline.show_only_force  -- if you show only forced spells if no then hide spell
	
	if self.db.profile.classCooldowns[self.myCLASS][spellName] then	
		if force then
			if self.db.profile.classCooldowns[self.myCLASS][spellName].hide_splash then 
				return false
			else
				return true
			end
		else
			return self.db.profile.classCooldowns[self.myCLASS][spellName].hide_splash
		end
	end
	if self.db.profile.internal_cooldowns[spellName] then	
		if force then
			if self.db.profile.internal_cooldowns[spellName].hide_splash then 
				return false
			else
				return true
			end
		else
			return self.db.profile.internal_cooldowns[spellName].hide_splash
		end
	end
	
	if self.db.profile.cooldownline.block[spellName] then 
		if force then
			if self.db.profile.cooldownline.block[spellName].hide_splash then 
				return false
			else
				return true
			end
		else
			return self.db.profile.cooldownline.block[spellName].hide_splash
		end
	end
	
	return force
end

function SPTimers:GetCooldownColor(spellName)
	if self.db.profile.classCooldowns[self.myCLASS][spellName] and 
		( self.db.profile.classCooldowns[self.myCLASS][spellName].color_on or self.db.profile.classCooldowns[self.myCLASS][spellName].color_on == nil ) then		
		return self.db.profile.classCooldowns[self.myCLASS][spellName].color		
	end
	
	if self.db.profile.internal_cooldowns[spellName] and 
		( self.db.profile.internal_cooldowns[spellName].color_on or self.db.profile.internal_cooldowns[spellName].color_on == nil ) then		
		return self.db.profile.internal_cooldowns[spellName].color		
	end
	
	return nil
end

function SPTimers:GetInternalCD(spellName, spellID)
	if self.db.profile.hideinternal then return false end
	if self.db.profile.internal_cooldowns[spellName] and not self.db.profile.internal_cooldowns[spellName].hide then 
		if self.db.profile.internal_cooldowns[spellName].checkID then		
			if self.db.profile.internal_cooldowns[spellName].spellID == spellID then
				return true
			end
			return false
		else
			return true
		end
	end
	return false
end

function SPTimers:GetPlayerCooldownList()
	return self.db.profile.classCooldowns[self.myCLASS]
end

function SPTimers:GetICD(spellName, spellID)

	if self.db.profile.internal_cooldowns[spellName].icd then
		return self.db.profile.internal_cooldowns[spellName].icd
	end
	
	return 0
end

do
	local cd_type = {
		["PLAYER_ITEMS"]	= "inv_color",
		["BAG_SLOTS"]		= "bag_color",
		["PET_CD"]			= "pet_color",
		["VEHICLE_CD"]		= "veh_color",
		["PLAYER_CD"]		= "pla_color",
		["INTERNAL_CD"]		= "inter_color",
		["RuneBlood"]		= "blood_runes_color",
		["RuneUnholy"]		= "unholy_runes_color",
		["RuneFrost"]		= "frost_runes_color",
		}
		--[[
			pla_color = {1,0.5,0,1},
						veh_color = {1,0.5,0,1},
						pet_color = {1,0,.95,1},
						bag_color = {1,1,0,1},
						inv_color = {1,1,0,1},
						inter_color = {0, 0.6, 0.85, 1},
		
		]]
	function SPTimers:GetCooldownTypeColor(types)
		if cd_type[types] then
			return self.db.profile.cooldownline[cd_type[types]]	
		end
		
		return self.db.profile.cooldownline.pla_color
	end
end

do
	-- inv_reporting
	-- bag_reporting
	
	-- veh_reporting
	-- icd_reporting
	-- pet_reporting
	-- player_reporting
		
		local cd_type = {
			["PLAYER_ITEMS"]	= "inv_reporting",
			["BAG_SLOTS"]		= "bag_reporting",
			["PET_CD"]			= "pet_reporting",
			["VEHICLE_CD"]		= "veh_reporting",
			["PLAYER_CD"]		= "player_reporting",
			["INTERNAL_CD"]		= "icd_reporting",
			["RuneBlood"]		= "br_reporting",
			["RuneUnholy"]		= "uh_reporting",
			["RuneFrost"]		= "fr_reporting",
		}
		
	function SPTimers:GetAnonce(name, tip)

			if cd_type[tip] then
				
				if self.db.profile.classCooldowns[self.myCLASS][name] then					
					if self.db.profile.classCooldowns[self.myCLASS][name].reporting == false then return false end
					if self.db.profile.classCooldowns[self.myCLASS][name].reporting == true then return true end
				end
				
				if self.db.profile.internal_cooldowns[name] then				
					if self.db.profile.internal_cooldowns[name].reporting == false then return false end
					if self.db.profile.internal_cooldowns[name].reporting == true then return true end
				end
				
				if self.db.profile.cooldownline.block[name] then				
					if self.db.profile.cooldownline.block[name].reporting == false then return false end
					if self.db.profile.cooldownline.block[name].reporting == true then return true end
				end

				if self.db.profile.cooldownline[cd_type[tip]] == false then return false end
				if self.db.profile.cooldownline[cd_type[tip]] == true then return true end

			end
			
		return false
	end
end

function SPTimers:RebuildBanCD()
	for k,v in pairs(self.db.profile.cooldownline.block) do
	
		if k and type(v) == "boolean" then
			self.db.profile.cooldownline.block[k] = { hide = v }	
		end
	end
end

------------------------------------------------------ check only @player auras
--[[
function SPTimers:GetRaidBuffsFilter(spellID)
	if raidBuffs[spellID] then return raidBuffs[spellID] end
	return false
end

local filters = {
	L["None"],
	L["Only buff"],
	L["Only debuff"],
	L["All"],
}


]]


-------------------------------------------------------- Unit Aura checking

-- true пропускает ауру через фильтр false запрещает
do
	function SPTimers:GetBlackListFilter(spellID, filter, skip) 
		if self.db.profile.classSpells[self.myCLASS][spellID] then
			
			if self.db.profile.classlistFiltersoff then return false end			
			if self.db.profile.classSpells[self.myCLASS][spellID].hide then return false end
			
			if self.db.profile.classSpells[self.myCLASS][spellID].blacklist == 4 then skip = false end			
			if self.db.profile.classSpells[self.myCLASS][spellID].blacklist == filter then skip = false end
			if self.db.profile.classSpells[self.myCLASS][spellID].hide then skip = false end
		end
		return skip
	end
end

do
	function SPTimers:GetWhiteListFilter(spellID, filter, skip)
		if self.db.profile.classSpells[self.myCLASS][spellID] then
			
			if self.db.profile.classlistFiltersoff then return false end			
			if self.db.profile.classSpells[self.myCLASS][spellID].hide then return false end
			
			if not self.db.profile.classSpells[self.myCLASS][spellID].whitelist or 
				self.db.profile.classSpells[self.myCLASS][spellID].whitelist == 1 then skip = true end
				
			if self.db.profile.classSpells[self.myCLASS][spellID].whitelist == 4 then skip = true end
			if self.db.profile.classSpells[self.myCLASS][spellID].whitelist == filter then skip = true end
		end
		return skip
	end
end

do
	function SPTimers:UnitFilter_UNIT(unit)
		local filter_type
		if self.db.profile.unit_filter_enabled then			
			if self.db.profile.unit_filters then
				
				filter_type = SPTimers:FindUnitUnit(unit) or "unknown"
				
				if filter_type and ( self.db.profile.unit_filters[filter_type] ) then				
					return true
				end
				return false
			end
		end
		return true
	end
	
	function SPTimers:UnitFilter_TIMER(timer)
		local filter_type
		if self.db.profile.unit_filter_enabled then			
			if self.db.profile.unit_filters then
				
				self:FindUnitGUID_SMO(timer.targetGUID)
				
				if timer.targetGUID then					
					filter_type = self:FindUnitGUID_SMO(timer.targetGUID) or "unknown"
				end
	
				if filter_type and self.db.profile.unit_filters[filter_type] then				
					return true
				end
				return false
			end
		end
		return true
	end
	
	function SPTimers:UnitFilter_GUID(guid)
		local filter_type
		if self.db.profile.unit_filter_enabled then			
			if guid then 
				filter_type = self:FindUnitGUID_SMO(guid) or "unknown"
			end
				
			if filter_type and self.db.profile.unit_filters[filter_type] then
				
--				print("SPTimers:UnitFilter_GUID", guid, filter_type, "true")
				return true
			end
--			print("SPTimers:UnitFilter_GUID", guid, filter_type, "false")
			return false
		end
--		print("SPTimers:UnitFilter_GUID", guid, filter_type, "SKIP")
		return true
	end
end


do
	function SPTimers:GetProcsFilter(spellID, types, skip) -- если true то пропустить заклинание
		if self.db.profile.procSpells[spellID] then
			
			if self.db.profile.procsFiltersoff then return false end			
			if self.db.profile.procSpells[spellID].hide then return false end

			
			if ( self.db.profile.procSpells[spellID].whitelist == nil ) or 
			   ( self.db.profile.procSpells[spellID].whitelist == 1   ) then skip = true end
				
			if self.db.profile.procSpells[spellID].whitelist == 4 then skip = true end
			if self.db.profile.procSpells[spellID].whitelist == types then skip = true end
			if self.db.profile.procSpells[spellID].blacklist == 4 then skip = false end			
			if self.db.profile.procSpells[spellID].blacklist == types then skip = false end
		end
		return skip
	end
end

do
	local none = "None"
	local none1 = "Interface\Quiet.ogg"
	
	function SPTimers:GetSound(spell, event)
	
		if not spell then return none end
		if event ~= "sound_onshow" and event ~= "sound_onhide" then return none end
		
		if self.db.profile.classSpells[self.myCLASS][spell] then
			return self.db.profile.classSpells[self.myCLASS][spell][event] or none
		end
		
		if self.db.profile.othersSpells[spell] then
			return self.db.profile.othersSpells[spell][event] or none	
		end
		
		if self.db.profile.procSpells[spell] then	
			return self.db.profile.procSpells[spell][event] or none
		end
		
		if self.db.profile.classCooldowns[self.myCLASS][spell] then	
			return self.db.profile.classCooldowns[self.myCLASS][spell][event] or none	
		end
		
		if self.db.profile.internal_cooldowns[spell] then	
			return self.db.profile.internal_cooldowns[spell][event] or none	
		end
	
		if self.db.profile.cooldownline.block[spell] then 
			return self.db.profile.cooldownline.block[spell][event] or none	
		end

		return none
	end
	
	--  Either "Master" (this will play the sound also with disabled sounds like before 4.0.1), "SFX", "Ambience", "Music
	
	function SPTimers:PlaySound(spell, event, bar)
		local sound = self:GetSound(spell, event)
		if sound == none then return end
		
		local sound2 = self.SharedMedia:Fetch("sound", sound)
		
		if event == "sound_onshow" then		
			if not bar.do_onshow then	
				local willplay, handler = PlaySoundFile(sound2, self.db.profile.sound_channel)	
				bar.do_onshow = true
		-- 		print(event, spell, willplay, handler, sound, bar:IsShown())
			end
		elseif event == "sound_onhide" then
			if not bar.do_onhide then	
				local willplay, handler = PlaySoundFile(sound2, self.db.profile.sound_channel)				
				bar.do_onhide = true
		--		print(event, spell, willplay, handler, sound, bar:IsShown())
			end		
		end
	end
	
	function SPTimers:PlaySoundCooldown(spell, event)
		local sound = self:GetSound(spell, event)		
		if sound == none then return end
		
		local sound2 = self.SharedMedia:Fetch("sound", sound)
		
		if event == "sound_onshow" then			
			local willplay, handler = PlaySoundFile(sound2, self.db.profile.sound_channel)
		elseif event == "sound_onhide" then	
			local willplay, handler = PlaySoundFile(sound2, self.db.profile.sound_channel)
		end
	end
end


do
	function SPTimers:GetOthersFilter(spellID, types, skip)
		if self.db.profile.othersSpells[spellID] then
		
			if self.db.profile.othersFiltersoff then return false end			
			if self.db.profile.othersSpells[spellID].hide then return false end
  
			if ( self.db.profile.othersSpells[spellID].whitelist == nil ) or 
			   ( self.db.profile.othersSpells[spellID].whitelist == 1   ) then skip = true end
			   
			if self.db.profile.othersSpells[spellID].whitelist == 4 then skip = true end
			if self.db.profile.othersSpells[spellID].whitelist == types then skip = true end
			if self.db.profile.othersSpells[spellID].blacklist == 4 then skip = false end			
			if self.db.profile.othersSpells[spellID].blacklist == types then skip = false end
		end
		return skip
	end
end

do

	local casterAuras = {
		[1490] 		= { 1490, 119653, 58410, 93068 },
		[119653] 	= { 1490, 119653, 58410, 93068 },
		[93068] 	= { 1490, 119653, 58410, 93068 },
	}
	
	local meleeAuras = {
		[81328] = { 81328, 113746 },
		[113746] = { 81328, 113746 },
	}
	
	local tankAuras = {
		[115798] = { 115798 },
	}
	
	function SPTimers:GetRaidDebuffListFilter(spellID, skip)

		if casterAuras[spellID] then skip = self.db.profile.casterTargetAura end
		if meleeAuras[spellID] then skip = self.db.profile.meleeTargetAura end	
		if tankAuras[spellID] then skip = self.db.profile.tankTargetAura end	
		
		return skip
	end
	
	function SPTimers:GetRaidDebuffList(spellID)

		if casterAuras[spellID] then return casterAuras[spellID] end
		if meleeAuras[spellID] then return meleeAuras[spellID] end	
		if tankAuras[spellID] then return tankAuras[spellID] end	
		
		return {}
	end
end

---------------------CLEU FILTER -------------------------

do
	local typesFilter = {
		["BUFF"] = 2,
		["DEBUFF"] = 3,
		["SPELL_CAST"] = 5,
		["SPELL_SUMMON"] = 6,
		["SPELL_ENERGIZE"] = 7,
	}
	
	function SPTimers:GetCLEUFilter(spellID, types)
		local skip = false
		if self.db.profile.classSpells[self.myCLASS][spellID] and self.db.profile.classSpells[self.myCLASS][spellID].cleu then
			
			if self.db.profile.classlistFiltersoff then return false end
			
			if self.db.profile.classSpells[self.myCLASS][spellID].hide then return false end
			
			if types ~= "SPELL_CAST" and not self.db.profile.classSpells[self.myCLASS][spellID].whitelist_cleu then skip = true end
			if self.db.profile.classSpells[self.myCLASS][spellID].whitelist_cleu == 4 then skip = true end
			if types and self.db.profile.classSpells[self.myCLASS][spellID].whitelist_cleu == typesFilter[types] then skip = true end
			
			if self.db.profile.classSpells[self.myCLASS][spellID].blacklist_cleu == 4 then skip = false end			
			if types and self.db.profile.classSpells[self.myCLASS][spellID].blacklist_cleu == typesFilter[types] then skip = false end
			
		end
		return skip
	end
	
	function SPTimers:GetCLEUSpellInfo(spellID)
		if self.db.profile.classSpells[self.myCLASS][spellID] then
			local haste		= self.db.profile.classSpells[self.myCLASS][spellID].haste
			local tick		= self.db.profile.classSpells[self.myCLASS][spellID].tick
			local pandemia	= self.db.profile.classSpells[self.myCLASS][spellID].pandemia
			return tick, haste, pandemia
		
		end
		
		return false
	end
	
	function SPTimers:IsChanneling(spellID)
		if self.db.profile.classSpells[self.myCLASS][spellID] then
			return self.db.profile.classSpells[self.myCLASS][spellID].channel
		end
		
		return false
	end
	
	
	function SPTimers:GetCastTime(spellID)
		if self.db.profile.classSpells[self.myCLASS][spellID] then	
		   if self.db.profile.classSpells[self.myCLASS][spellID].cast and
				self.db.profile.classSpells[self.myCLASS][spellID].cast > 0 then
		   
				local cast = self.db.profile.classSpells[self.myCLASS][spellID].cast+0.2

				return cast/(1+(UnitSpellHaste("player")/100))
			elseif self.db.profile.classSpells[self.myCLASS][spellID].withgcd then
			
				return 1.5/(1+(UnitSpellHaste("player")/100))*(-1)
			end
		end
		
		return 0
	end
	
	function SPTimers:TickOverlap(spellID)
		if self.db.profile.classSpells[self.myCLASS][spellID] and
			self.db.profile.classSpells[self.myCLASS][spellID].tickoverlap then
			
			return true
		end	
		return nil
	end
	
end

do
	
	--[[
	
		local affiliation = {
			L["Any"],
			L["player"],
			L["raid"],
			L["party"],
			L["pet"],
		}
	
	]]
	
	
	local COMBATLOG_OBJECT_TYPE_PLAYER = COMBATLOG_OBJECT_TYPE_PLAYER
	local COMBATLOG_OBJECT_AFFILIATION_RAID = COMBATLOG_OBJECT_AFFILIATION_RAID
	local COMBATLOG_OBJECT_AFFILIATION_PARTY = COMBATLOG_OBJECT_AFFILIATION_PARTY
	local COMBATLOG_OBJECT_AFFILIATION_MINE = COMBATLOG_OBJECT_AFFILIATION_MINE
	
	local bit_band = bit.band
	
	local function IsPlayer(dstFLAG)
		if bit.band(dstFLAG, TYPE_PLAYER) > 0 then return true end
		return false
	end
	
	local match = string.match
	
	local function IsRaidMember(flags)
		if bit_band(flags, COMBATLOG_OBJECT_AFFILIATION_RAID+COMBATLOG_OBJECT_AFFILIATION_PARTY) > 0 then return true end
		return false
	end
	
	local function IsPartyMember(flags)
		if bit_band(flags, COMBATLOG_OBJECT_AFFILIATION_PARTY) > 0 then return true end
		return false
	end
	
	local function IsMyFlags(flags)
		if bit_band(flags, COMBATLOG_OBJECT_AFFILIATION_MINE) > 0 then return true end
		return false
	end
	
	function SPTimers:GetAffiliation(spellid)
		if self.db.profile.classSpells[self.myCLASS][spellid] and
			self.db.profile.classSpells[self.myCLASS][spellid].source then 
			return self.db.profile.classSpells[self.myCLASS][spellid].source end
			
		if self.db.profile.procSpells[spellid] and
			self.db.profile.procSpells[spellid].source then 
			return self.db.profile.procSpells[spellid].source end
			
		if self.db.profile.othersSpells[spellid] and
			self.db.profile.othersSpells[spellid].source then 
			return self.db.profile.othersSpells[spellid].source end
		
		return 2
	end
	function SPTimers:CheckUnitSource(unit1, atype)
		if atype == 2 then
			return ( unit1 == "player" )
		elseif atype == 3 then
			return ( unit1 == match(unit1, "raid%d") or unit1 == match(unit1, "party%d") )
		elseif atype == 4 then
			return ( unit1 == match(unit1, "party%d") )
		elseif atype == 5 then
			return ( unit1 == match(unit1, "playerpet") or unit1 == match(unit1, "pet") )
		elseif atype == 1 then
			return true
		end
		return false		
	end
	
	function SPTimers:CLEU_TypeSource(flags, atype)
		if atype == 2 then
			return ( unit1 == "player" )
		elseif atype == 3 then
			return ( unit1 == match(unit1, "raid%d") or unit1 == match(unit1, "party%d") )
		elseif atype == 4 then
			return ( unit1 == match(unit1, "party%d") )
		elseif atype == 5 then
			return ( unit1 == match(unit1, "playerpet") or unit1 == match(unit1, "pet") )
		elseif atype == 1 then
			return true
		end
		return false
	end
end
-------------- aura duration --------------------------------
do
	SPTimers.pandemia_cache = {}
	
	local pandemia_cache = SPTimers.pandemia_cache
	
	local duration, tick, tick_count, tick_every
	local math_floor = math.floor
	local GetTime = GetTime
	
	local function Round(num) return math_floor(num+.5) end
	local function fullDuration(spellID, dstGUID, pandemia_t) -- pandemia_t 1 - refresh 2 - applied
		
		tick_every 	= SPTimers.db.profile.classSpells[SPTimers.myCLASS][spellID].tick/SPTimers.myHaste
		tick_count 	= Round(SPTimers.db.profile.classSpells[SPTimers.myCLASS][spellID].duration/tick_every)
		duration 	= tick_count * tick_every
		
		if SPTimers.db.profile.classSpells[SPTimers.myCLASS][spellID].pandemia then
			if pandemia_t == 2 then				
				if pandemia_cache[spellID..dstGUID] and ( pandemia_cache[spellID..dstGUID] - GetTime() > 0 ) then					
					if (pandemia_cache[spellID..dstGUID] - GetTime()) > duration*0.5 then					
						duration = duration + duration*0.5
					else
						duration = duration + (pandemia_cache[spellID..dstGUID] - GetTime())
					end					
					pandemia_cache[spellID..dstGUID] = GetTime()+duration		
				end
			elseif pandemia_t == 1 then		
				pandemia_cache[spellID..dstGUID] = GetTime()+duration
			end
		end
		return duration
	end
	
	function SPTimers:RemovePandemia(spellID, dstGUID)
		if SPTimers.db.profile.classSpells[SPTimers.myCLASS][spellID].pandemia then
			if pandemia_cache[spellID..dstGUID] then pandemia_cache[spellID..dstGUID] = nil end
		end
	end

	function SPTimers:GetDuration(spellID, dstGUID, pandemia_t, isplayer)
		if	self.db.profile.classSpells[self.myCLASS][spellID].haste then
			if SPTimers.db.profile.classSpells[SPTimers.myCLASS][spellID].tick and
			SPTimers.db.profile.classSpells[SPTimers.myCLASS][spellID].duration then
				return fullDuration(spellID, dstGUID, pandemia_t)
			end
		end
		
		if self.db.profile.classSpells[self.myCLASS][spellID].pvpduration and isplayer then
			return self.db.profile.classSpells[self.myCLASS][spellID].pvpduration or self.db.profile.classSpells[self.myCLASS][spellID].duration
		end
		
		return self.db.profile.classSpells[self.myCLASS][spellID].duration
	end
end
----------------------------------------------------------

function SPTimers:GetCustomText(spellID)
	if self.db.profile.classSpells[self.myCLASS][spellID] and
		self.db.profile.classSpells[self.myCLASS][spellID].custom_text_on then
		
		return self.db.profile.classSpells[self.myCLASS][spellID].custom_text
	end
	if self.db.profile.procSpells[spellID] and
		self.db.profile.procSpells[spellID].custom_text_on then
		
		return self.db.profile.procSpells[spellID].custom_text
	end
	if self.db.profile.othersSpells[spellID] and
		self.db.profile.othersSpells[spellID].custom_text_on then
		
		return self.db.profile.othersSpells[spellID].custom_text
	end
	
	return false
end


function SPTimers:SetupAuras(options)
	
	self.myGUID = UnitGUID("player")

	local _,class = UnitClass("player")	
	self.myCLASS = class

	options.profile.procSpells = procs
	options.profile.othersSpells = others
	options.profile.internal_cooldowns = internal_cooldowns
	
	
	if self.SetupClassSpells then
		options.profile.classSpells[class] = self:SetupClassSpells()
	end
	
	if self.SetupClassCooldowns then
		options.profile.classCooldowns[class] = self:SetupClassCooldowns()
		
	end
	
	return options
end

--- AFFDOTS -----------------------

do
	
	local dot_damage, targets, find_color, affdots_o
	
	if AffDots then
		dot_damage, targets    = AffDots.dot_damage, AffDots.targets
		find_color			 = AffDots.FindColor
		affdots_o				 = AffDots.db.profile
	end
	
	local GetTime				 = GetTime
		
	local color_cache = {}

	function SPTimers:AffDotsParse(frame)
		
		if not AffDots then return "NoAffDots" end

		local spell_id	= frame.spellID
		local target 	= frame.targetGUID		
		local timeleft  = frame.endTime - GetTime()		
		local color 	= find_color(AffDots, target, timeleft, spell_id, frame.duration*0.5)
		
		if not color_cache[color] then	
			color_cache[color] = ("|cff%02x%02x%02x"):format(affdots_o["color"..color][1] * 255, affdots_o["color"..color][2] * 255, affdots_o["color"..color][3] * 255)
		end
		
		if dot_damage[spell_id] and targets[target..spell_id] then
		
			text = math.floor((dot_damage[spell_id][1]*100/targets[target..spell_id][1])+.5)
			
			return color_cache[color]..text.."|r"
		end
		
		return "no_value"
	end
end



