local _,class = UnitClass("player")
local L = LibStub("AceLocale-3.0"):GetLocale("SPTimers")

if class ~= "DEATHKNIGHT" then return end

local colors = SPTimers.CustomColors

--[[
	blood_runes = true,
	frost_runes = true,
	unholy_runes = true,
					
	blood_runes_color = {1, 0, 0, 1},
	frost_runes_color = {0, 0.43, 1, 1},
	unholy_runes_color = {0.2, 0.8, 0, 1},
]]

local spells = { 
	
	[55095] = { color = colors.CHILL, duration = 30 },
	[55078] = { color = colors.PURPLE, duration = 30 },
	[43265] = { color = colors.RED, duration = 10, group = "player", cleu = true, whitelist_cleu = 5, blacklist_cleu = 3, blacklist = 3 },
	[114866] = { color = colors.BLACK, duration = 5 },
	[130735] = { color = colors.BLACK, duration = 5 },
	[130736] = { color = colors.BLACK, duration = 5 },
	[73975]  = { duration = 10, color = colors.WOO },
	
	[56222]  = { color = colors.TAUNT, duration = 3 },
	[55233]  = { duration = 10, color = colors.RED },
	[81256]  = { duration = 12, color = colors.BROWN },
	[49222]  = { duration = 300, color = colors.WOO2 },
	
	[81141]  = { duration = 15, color = colors.LRED },
	[50421]  = { duration = 30, color = colors.WOO2 },
	[45524]  = { duration = 8, color = colors.CHILL },
	[48792]  = { duration = 12 },
	[51124]  = { duration = 30, color = colors.LRED, group = "procs", },
	[59052]  = { duration = 15, color = colors.WOO2, group = "procs", },
	[49039]  = { duration = 10, color = colors.BLACK },
	[91342]  = { duration = 30, color = colors.LGREEN}, -- "Shadow Infusion" pet
	[63560]  = { duration = 30, color = colors.LGREEN }, -- "Dark Transformation"
	[81340]  = { duration = 10, color = colors.CURSE },
	[47476]  = { cleu = true, duration = 5 },	
	[91800]  = { cleu = true, duration = 3, color = colors.RED }, -- pet
	[91797]  = { cleu = true, duration = 4, color = colors.RED }, -- pet
	[49016]  = { duration = 30, color = colors.LRED },
	[48707]  = { duration = 5,  color = colors.LGREEN },
	
	[51052]  = { cleu = true, color = colors.GOLD, duration = 3, group = "player", whitelist_cleu = 5, blacklist_cleu = 2, blacklist = 4 },
	[116888] = { color = colors.LGREEN, duration = 3 },
	[108194] = { cleu = true, color = colors.PINK, duration = 5 }, 
	[96268]  = { color = colors.PINK, duration = 6 },
	[114851] = { color = colors.DRED, duration = 24 },

}
		
		
function SPTimers:SetupClassSpells()

	self.myCLASS = class
	
	return spells
end

function SPTimers:SetupClassOptions()
	local order = 60
	
	self.options.args.coolline.args.DKrunes = {
			type = "header",
			name = "Death Knight Runes",
			order = order+1,
			}
	
	
	self.options.args.coolline.args.blood_runes_color = {					
						type = "group",	order = order+2,
						guiInline = true,
						name	= L["Blood"],
						args = {
							player_color = {
								order = 1, name = L["Color"],type = "color", hasAlpha = false, width = "half",
								set = function(info,r,g,b) self.db.profile.cooldownline.blood_runes_color={r,g,b} end,
								get = function(info) return self.db.profile.cooldownline.blood_runes_color[1],self.db.profile.cooldownline.blood_runes_color[2],self.db.profile.cooldownline.blood_runes_color[3],1 end
								},
							hide_player = {
								order = 2,name = L["Hide"],type = "toggle", width = "half",
								set = function(info,val) self.db.profile.cooldownline.blood_runes = not self.db.profile.cooldownline.blood_runes; end,
								get = function(info) return self.db.profile.cooldownline.blood_runes end
								},
							annonce = {
								order = 3,name = L["Reporting"], type = "toggle", width = "half",
								desc = L["Turn on/off spell cooldown report"],
								set = function(info,val) self.db.profile.cooldownline.br_reporting = not self.db.profile.cooldownline.br_reporting end,
								get = function(info) return self.db.profile.cooldownline.br_reporting end
							}
						},
					}
	
	self.options.args.coolline.args.frost_runes_color = {					
						type = "group",	order = order+3,
						guiInline = true,
						name	= L["Frost"],
						args = {
							player_color = {
								order = 1, name = L["Color"],type = "color", hasAlpha = false, width = "half",
								set = function(info,r,g,b) self.db.profile.cooldownline.frost_runes_color={r,g,b} end,
								get = function(info) return self.db.profile.cooldownline.frost_runes_color[1],self.db.profile.cooldownline.frost_runes_color[2],self.db.profile.cooldownline.frost_runes_color[3],1 end
								},
							hide_player = {
								order = 2,name = L["Hide"],type = "toggle", width = "half",
								set = function(info,val) self.db.profile.cooldownline.frost_runes = not self.db.profile.cooldownline.frost_runes; end,
								get = function(info) return self.db.profile.cooldownline.frost_runes end
								},
							annonce = {
								order = 3,name = L["Reporting"], type = "toggle", width = "half",
								desc = L["Turn on/off spell cooldown report"],
								set = function(info,val) self.db.profile.cooldownline.fr_reporting = not self.db.profile.cooldownline.fr_reporting end,
								get = function(info) return self.db.profile.cooldownline.fr_reporting end
							}
						},
					}

	self.options.args.coolline.args.uncholy_runes_color = {					
						type = "group",	order = order+4,
						guiInline = true,
						name	= L["Unholy"],
						args = {
							player_color = {
								order = 1, name = L["Color"],type = "color", hasAlpha = false, width = "half",
								set = function(info,r,g,b) self.db.profile.cooldownline.unholy_runes_color={r,g,b}; end,
								get = function(info) return self.db.profile.cooldownline.unholy_runes_color[1],self.db.profile.cooldownline.unholy_runes_color[2],self.db.profile.cooldownline.unholy_runes_color[3],1 end
								},
							hide_player = {
								order = 2,name = L["Hide"],type = "toggle", width = "half",
								set = function(info,val) self.db.profile.cooldownline.unholy_runes = not self.db.profile.cooldownline.unholy_runes end,
								get = function(info) return self.db.profile.cooldownline.unholy_runes end
								},
							annonce = {
								order = 3,name = L["Reporting"], type = "toggle", width = "half",
								desc = L["Turn on/off spell cooldown report"],
								set = function(info,val) self.db.profile.cooldownline.uh_reporting = not self.db.profile.cooldownline.uh_reporting end,
								get = function(info) return self.db.profile.cooldownline.uh_reporting end
							}
						},
					}

end