local local_class ,class = UnitClass("player")
local L = LibStub("AceLocale-3.0"):GetLocale("SPTimers")

if class ~= "DRUID" then return end

local colors = SPTimers.CustomColors

local spells = { 
	[339] 		= { duration = 30 , cleu = true },
	[48391] 	= { duration = 10 },
	[78675] 	= { duration = 10, color = colors.GOLD, cleu = true, group = "player", whitelist_cleu = 5 },
	
	[2637]		= { duration = 40, pvpduration = 8 },
	[33786] 	= { duration = 6 },
	[8921]  	= { duration = 14, cleu = true, color = colors.PURPLE, tick = 2, haste = true },
	[93402] 	= { duration = 14, cleu = true, color = colors.ORANGE, tick = 2, haste = true },
	[93400] 	= { group = "procs", duration = 12, color = colors.CURSE },
	[106951] 	= { group = "player" }, -- cat
	[50334] 	= { group = "player" }, -- bear
	
	[9005] 		= { duration = 4, color = colors.PINK },
	[9007] 		= { color = colors.RED, duration = 18, cleu = true },
	[1822] 		= { duration = 15, tick = 3, color = colors.LRED, cleu = true },
	[1079] 		= { duration = 16, tick = 2, color = colors.RED, cleu = true },
	[22570] 	= { color = colors.PINK, duration = 5 },
	[5217] 		= { color = colors.LBLUE },
	[52610] 	= { color = colors.PURPLE },
	[127538] 	= { color = colors.PURPLE, duration = 12 },
	[1850] 		= { duration = 15 },
	[81022] 	= { duration = 8 },
	
	[132402] 	= { group = "player", duration = 6, color = colors.WOO2 },
	[106922] 	= { group = "player", duration = 20, color = colors.BLACK },
	[99] 		= { duration = 3, cleu = true },
	[6795] 		= { duration = 3, color = colors.TAUNT  },
	[33745] 	= { group = "target", duration = 15, color = colors.RED },
	[5211]  	= { duration = 5, cleu = true, color = colors.PINK },
	
	[77758]  	= { duration = 16, tick = 2, color = colors.LBLUE },
	[106830]	= { duration = 16, tick = 2, color = colors.LBLUE },
	[93622] 	= { group = "procs", color = colors.CURSE, duration = 5 },
	[102795] 	= { duration = 3, color = colors.RED },
	[102359] 	= { duration = 20, color = colors.BROWN },
	
	--[[
	[102351] = { group = "player", duration = 30, color = colors.WOO2 },
	[102352] = { group = "player", duration = 6, color = colors.TEAL },
	]]
	
	[117679] 	= { group = "player", duration =  30, color = colors.TEAL2 },
	[102558] 	= { group = "player", duration =  30, color = colors.TEAL2 },
	[102560] 	= { group = "player", duration =  30, color = colors.TEAL2 },
	[102543] 	= { group = "player", duration =  30, color = colors.TEAL2 },
	
	[144865]	= { group = "player" },
	
	[102342] 	= { group = "player", duration = 12 },
	[22812]  	= { group = "player", duration = 12 },
	[61336]  	= { group = "player", color = colors.BLACK, duration = 12 },
	[124974] 	= { color = colors.TEAL2, duration = 30 },
	[132158] 	= { group = "player", color = colors.TEAL },
	[774]		= { source = 2, group = "player", duration = 12, color = colors.REJUV },
	[8936] 	 	= { group = "player", duration = 6, color = colors.REGROW },
	[33763]  	= { source = 2, cleu = true, duration = 10},
	[48438]  	= { cleu = true, duration = 7, color = colors.LGREEN },
	[29166]  	= { cleu = true, duration = 10 },
	[100977] 	= { group = "player", color = colors.BLACK, cast = 2.5, duration = 10 },
	
	[145162]	= { color = colors.ELV_RAGE, }, -- cleu = true, whitelist_cleu = 2, duration = 20},
	[145151]	= { color = colors.ELV_RAGE, }, -- cleu = true, whitelist_cleu = 2, duration = 30},
	[145152]	= { color = colors.ELV_RAGE, }, -- cleu = true, whitelist_cleu = 2, duration = 30},
	
}

local cooldown = {
	[GetSpellInfo(78674)] = { spellid = 78674, color = colors.CURSE },
	[GetSpellInfo(5217)] = { spellid = 5217, color = colors.LBLUE },
	[GetSpellInfo(77758)] = { spellid = 77758, color = colors.LBLUE },
	[GetSpellInfo(33745)] = { spellid = 33745, color = colors.PURPLE },
	[GetSpellInfo(33878)] = { spellid = 33878, color = colors.CURSE },
}


function SPTimers:SetupClassSpells() self.myCLASS = class; return spells end
function SPTimers:SetupClassCooldowns() self.myCLASS = class; return cooldown end


function SPTimers:SetupClassOptions()
	local order = 41
	
	self.options.args.bars.args[class] = {
			type = "header",
			name = local_class,
			order = order,
			}
	for i=1, 3 do
		
		order = order+ 3 + (6*(i-1))
		
		self.options.args.bars.args["headertotem"..i] = {
			type = "header",
			name = L[class.." totem1"],
			order = order+1*i,
			}
			
		self.options.args.bars.args["showtotem"..i] = {
			order = order+(2*i),name = L["Show"],type = "toggle",
			set = function(info,val) self.db.profile.totems["totem"..i].show = not self.db.profile.totems["totem"..i].show; self:UpdateTotems() end,
			get = function(info) return self.db.profile.totems["totem"..i].show end
			}
		self.options.args.bars.args["colortotem"..i] = {
			order = order+(3*i),name = L["Color"], type = "color", hasAlpha = false,
			set = function(info,r,g,b) self.db.profile.totems["totem"..i].color ={r,g,b,1} end,
			get = function(info) return self.db.profile.totems["totem"..i].color[1],self.db.profile.totems["totem"..i].color[2],self.db.profile.totems["totem"..i].color[3],1 end
		}
		
		self.options.args.bars.args["prioritytotem"..i] = {
				name = L["Priority"],
				type = "range",
				order	= order+(4*i),
				min		= -20,
				max		= 20,
				step	= 1,
				set = function(info,val) 
					self.db.profile.totems["totem"..i].priority = val
				end,
				get = function(info)
					return self.db.profile.totems["totem"..i].priority
				end,
			}
		self.options.args.bars.args["anchortotem"..i] = {
				name = L["Select Anchor"],
				order = order+(5*i),
				desc = L["Select Anchor Desc"],
				type = "select",
				values = function()
					local t = {}							
					for k,v in ipairs(self.db.profile.bars_anchors) do						
						t[k] = ""..k..""
					end							
					return t
				end,
				set = function(info,val)
					self.db.profile.totems["totem"..i].anchor = val
				end,
				get = function(info, val) 
					return self.db.profile.totems["totem"..i].anchor or 1
				end
			}
		self.options.args.bars.args["grouptotem"..i] = {
				name = L["Select group"],
				order = order+(6*i),
				desc = L["Select group Desc"],
				type = "select",
				values = function()		
					return {
						["player"] = "player",
						["procs"]  = "procs",
						["auto"]   = "auto",
						["target"] = "target",
					}
				end,
				set = function(info,val)
					self.db.profile.totems["totem"..i].group = val
				end,
				get = function(info, val) 
					return self.db.profile.totems["totem"..i].group or "auto"
				end
			}
	end
end