local local_class,class = UnitClass("player")
local L = LibStub("AceLocale-3.0"):GetLocale("SPTimers")

if class ~= "SHAMAN" then return end
local colors = SPTimers.CustomColors

local spells = {

	[8056] = { duration = 8, color = colors.CHILL, cleu = true },
	[16188] = { duration = 1, color = colors.TEAL },
	[61295] = { duration = 15, color = colors.FROZEN, cleu = true },
	[76780] = { duration = 50, pvpduration = 8, color = colors.PINK, cleu = true  },
	[51514] = { cleu = true, duration = 50, pvpduration = 8, color = colors.CURSE },
	[79206] = { duration = 10, color = colors.LGREEN },
	
	[8050] = { custom_text = "[%affdots]%tN", cleu = true, duration = 18, color = colors.PURPLE },
	[16166] = { duration = 30, color = colors.CURSE },
	[77762] = { duration = 6, color = colors.FIRE },
	[30823] = { duration = 15, color = colors.BLACK },
	
	[53817] = { duration = 12, color = colors.PURPLE},
	[114050] = { duration = 15, color = colors.PINK },
	[114051] = { duration = 15, color = colors.PINK },
	[114052] = { duration = 15, color = colors.PINK },
	
	[108271] = { duration = 6, color = colors.BLACK },
	[63685]  = { duration = 5, color = colors.FROZEN },
	[73920]  = { duration = 5, color = colors.FROZEN },
	
	[51730] = { duration = 3600, color = colors.BLACK },
	[8024]  = { duration = 3600, color = colors.BLACK },
	[8033]  = { duration = 3600, color = colors.BLACK },
	[8017]  = { duration = 3600, color = colors.BLACK },
	[8232]  = { duration = 3600, color = colors.BLACK },

}
local cooldown = {
	
	[GetSpellInfo(8056)] = { spellid = 8056, color = colors.LRED },
	[GetSpellInfo(51505)] = { spellid = 51505, color = colors.RED },
	[GetSpellInfo(117014)] = { spellid = 117014, color = colors.BLACK },
	[GetSpellInfo(17364)] = { spellid = 17364, color = colors.CURSE },
	[GetSpellInfo(73680)] = { spellid = 73680, color = colors.WOO },
	[GetSpellInfo(60103)] = { spellid = 60103, color = colors.RED },

}




function SPTimers:SetupClassSpells() self.myCLASS = class; return spells end
function SPTimers:SetupClassCooldowns() self.myCLASS = class; return cooldown end

function SPTimers:SetupClassOptions()
	local order = 41
	
	self.options.args.bars.args.Shaman = {
			type = "header",
			name = local_class,
			order = order,
			}

	self.options.args.bars.args.showenchants = {
			order = order+1,name = L["Show enchants"],type = "toggle", width = "full",
			set = function(info,val) self.db.profile.showenchants = not self.db.profile.showenchants; self:UpdateEnchants() end,
			get = function(info) return self.db.profile.showenchants end
			}
	
	for i=1, MAX_TOTEMS do
		
		order = order+ 3 + (6*(i-1))
		
		self.options.args.bars.args["headertotem"..i] = {
			type = "header",
			name = L[class.." totem"..i],
			order = order+1*i,
			}
			
		self.options.args.bars.args["showtotem"..i] = {
			order = order+(2*i),name = L["Show"],type = "toggle",
			set = function(info,val) self.db.profile.totems["totem"..i].show = not self.db.profile.totems["totem"..i].show; self:UpdateTotems() end,
			get = function(info) return self.db.profile.totems["totem"..i].show end
			}
		self.options.args.bars.args["colortotem"..i] = {
			order = order+(3*i),name = L["Color"], type = "color", hasAlpha = false,
			set = function(info,r,g,b) self.db.profile.totems["totem"..i].color ={r,g,b,1} end,
			get = function(info) return self.db.profile.totems["totem"..i].color[1],self.db.profile.totems["totem"..i].color[2],self.db.profile.totems["totem"..i].color[3],1 end
		}
		
		self.options.args.bars.args["prioritytotem"..i] = {
				name = L["Priority"],
				type = "range",
				order	= order+(4*i),
				min		= -20,
				max		= 20,
				step	= 1,
				set = function(info,val) 
					self.db.profile.totems["totem"..i].priority = val
				end,
				get = function(info)
					return self.db.profile.totems["totem"..i].priority
				end,
			}
		self.options.args.bars.args["anchortotem"..i] = {
				name = L["Select Anchor"],
				order = order+(5*i),
				desc = L["Select Anchor Desc"],
				type = "select",
				values = function()
					local t = {}							
					for k,v in ipairs(self.db.profile.bars_anchors) do						
						t[k] = ""..k..""
					end							
					return t
				end,
				set = function(info,val)
					self.db.profile.totems["totem"..i].anchor = val
				end,
				get = function(info, val) 
					return self.db.profile.totems["totem"..i].anchor or 1
				end
			}
		self.options.args.bars.args["grouptotem"..i] = {
				name = L["Select group"],
				order = order+(6*i),
				desc = L["Select group Desc"],
				type = "select",
				values = function()		
					return {
						["player"] = "player",
						["procs"]  = "procs",
						["auto"]   = "auto",
						["target"] = "target",
					}
				end,
				set = function(info,val)
					self.db.profile.totems["totem"..i].group = val
				end,
				get = function(info, val) 
					return self.db.profile.totems["totem"..i].group or "auto"
				end
			}
	end
end