﻿SPTimers = LibStub("AceAddon-3.0"):NewAddon("SPTimers","AceEvent-3.0")
SPTimers.SharedMedia = LibStub("LibSharedMedia-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("SPTimers")
local ACD = LibStub("AceConfigDialog-3.0")

local message

----- minimap button config ---------------------------
local SPTimersLDB = LibStub("LibDataBroker-1.1"):NewDataObject("SPTimers Minimap", {
	type = "data source",
	text = "SPTimers",
	icon = "Interface\\Icons\\spell_shadow_shadowwordpain",
	OnClick = function()
		if not InCombatLockdown() then
			if ACD.OpenFrames["SPTimers"] then
				ACD:Close("SPTimers")
				SPTimers.delayOpeningOptions = false
			else
				ACD:Open("SPTimers")
			end
		else
			SPTimers.delayOpeningOptions = true		
			message(L["You can't do that while in combat"])	
		end
	end,
})
local minimap_icon = LibStub("LibDBIcon-1.0")
--------------------------------------------------------

local parent = CreateFrame('Frame', 'SPTimersParent', UIParent);
parent:SetFrameLevel(UIParent:GetFrameLevel());
parent:SetPoint('CENTER', UIParent, 'CENTER');
parent:SetSize(UIParent:GetSize());

SPTimers.Parent = parent

-- locals -----------------------

local myGUID, myCLASS
local options
local UnitGUID = UnitGUID
local math_floor = math.floor
local L = LibStub("AceLocale-3.0"):GetLocale("SPTimers")
local pairs = pairs
local ipairs = ipairs
local tinsert = table.insert

-- debug print ------------------
local old_print = print
local print = function(...)
	if SPTimers.dodebugging then	
		old_print(GetTime(), "SPTimers_CORE, ", ...)
	end
end

local old_assert = assert
local assert = function(...)
	if SPTimers.dodebugging then	
		old_assert(...)
	end
end

do
	local SendChatMessage = SendChatMessage
	local IsInRaid, IsInGroup = IsInRaid, IsInGroup
	
	function SPTimers.ChatMessage(msg, chat)
		
		if chat == "RAID_WARNING" then
			SendChatMessage(msg, "RAID_WARNING")
		elseif chat == "PARTY" then
			SendChatMessage(msg, "PARTY")
		elseif chat == "GUILD" then
			SendChatMessage(msg, "GUILD")
		else
			local chatType = "PRINT"
			if IsInGroup(LE_PARTY_CATEGORY_INSTANCE) or IsInRaid(LE_PARTY_CATEGORY_INSTANCE) then
				chatType = "INSTANCE_CHAT"
			elseif IsInRaid(LE_PARTY_CATEGORY_HOME) then
				chatType = "RAID"
			elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then
				chatType = "PARTY"
			end
			
			if chatType == "PRINT" then
				SPTimers.message(msg)
			else
				SendChatMessage(msg, chatType)
			end
		end
	--	AddOn:print("Message", msg, chatType)
	end
end


do
	local select = select
	local tostring = tostring
	local sub = string.sub	
	local icon = "\124TInterface\\Icons\\spell_shadow_shadowwordpain:10\124t"
	
	function SPTimers.message(...)
	--	old_print("SPTimers_Options:", ...)
		local msg = ""
		for i=1, select("#", ...) do
			
			msg = msg..tostring(select(i, ...))..","
		end	
		msg = sub(msg, 0, -2)
		
		DEFAULT_CHAT_FRAME:AddMessage(icon.."SPTimers:"..msg)	
	end

end

message = SPTimers.message

---------------------------------

local function Round(num) return math_floor(num+.5) end
local function SecondsRound(num)
	if num > 2 then return math_floor(num+.5)
	else return math_floor(num*10+.5)/10 end
end


SLASH_SPTIMERS1 = '/sptimers'
function SPTimersHandler(msg, editBox)
	LibStub("AceConfigDialog-3.0"):Open("SPTimers")
end
SlashCmdList["SPTIMERS"] = SPTimersHandler


do
	SPTimers.targetEngaged = {}
	SPTimers.onUpdateHandler  = CreateFrame("Frame", "SPTimers-OnUpdate_Handler:core")
	
	local onUpdateHandler = SPTimers.onUpdateHandler	
	onUpdateHandler.elapsed = 0
	onUpdateHandler.active = false

	local function onUpdateCombat(self, elapsed)
		self.elapsed = self.elapsed + elapsed
		if self.elapsed < options.throttleOutCombat then return end		
		self.elapsed = 0

		if not IsEncounterInProgress() and not InCombatLockdown() then
			self.active = false
			wipe(SPTimers.targetEngaged)
			wipe(SPTimers.pandemia_cache)
			SPTimers:OnCombatEndReset()
			self:SetScript("OnUpdate", nil)
	
		else
			local current = GetTime()
			for guid, last in pairs(SPTimers.targetEngaged) do				
				if last <= current then
					SPTimers:RemoveTimers(guid, "DEBUFF")
					SPTimers.targetEngaged[guid] = nil	
				--	print("Clear DestGUID", guid)
				end	
			end
		end	
	end
	
	--onUpdateHandler:SetScript("OnUpdate", onUpdateCombat)
	
	function SPTimers:MouseOverOnUpdate()
		if onUpdateHandler.active == false and not SPTimers.testbar_shown then		
			onUpdateHandler:SetScript("OnUpdate", onUpdateCombat)
			onUpdateHandler.elapsed = -5
			onUpdateHandler.active = true
		end
	end
	
	function SPTimers:PLAYER_REGEN_ENABLED() 
		onUpdateHandler.elapsed = 0
		
		if self.delayOpeningOptions then
			ACD:Open("SPTimers")
			SPTimers.delayOpeningOptions = false
		end
	end
	
	
	function SPTimers:PLAYER_REGEN_DISABLED()	
		if ACD.OpenFrames["SPTimers"] then 
			self.delayOpeningOptions = true
			ACD:Close("SPTimers")
		end
		
		if options.bar_module_enabled then
			onUpdateHandler:SetScript("OnUpdate", onUpdateCombat)
			if SPTimers.testbar_shown then self:TestBars(true) end
		end
		onUpdateHandler.active = true
	end
end
	
function SPTimers:MODIFIER_STATE_CHANGED(event,key,state)

end



do
	local spellicon_cashe = {}
	
	function SPTimers:GetSpellIcon(spellID)
		if not spellicon_cashe[spellID] then
			local name, rank, icon = GetSpellInfo(spellID)
			spellicon_cashe[spellID] = icon
			
			return spellicon_cashe[spellID]
		else
			return spellicon_cashe[spellID]
		end
	end
end

do
	
	local engageThrottle = 30
	
	local destGUID, sourceGUID, targetName, sourceName
		
	local string_match = string.match
	local wipe, tinsert = wipe, table.insert
	
	local UnitGUID = UnitGUID
	local UnitName = UnitName
	local UnitExists = UnitExists
	
	local UnitDebuff = UnitDebuff
	local UnitBuff = UnitBuff
	local UnitAura = UnitAura
	
	local GetTime = GetTime

	local buffUnits = {
		player = 1,
		playerpet = 1,
		}

	SPTimers.unitThrottle = {
		target = 0,
		pettarget = 0,
		arena1 = 0,
		arena2 = 0,
		arena3 = 0,
		arena4 = 0,
		arena5 = 0,
		focus  = 0,
		boss1  = 0,
		boss2  = 0,
		boss3  = 0,
		boss4  = 0,
		boss5  = 0
	}
	local unitThrottle = SPTimers.unitThrottle
	
	local checkUnitOnUpdate = CreateFrame("Frame", "SPTimers-OnUpdateFrame:core")
	
	SPTimers.checkUnitOnUpdate = checkUnitOnUpdate 
	
	checkUnitOnUpdate.elapsed = -5
	
	SPTimers.checkUnitOnUpdateFunc = function(self, elapsed)
		self.elapsed = self.elapsed + elapsed
		
		if self.elapsed > 0.25 then
			self.elapsed = 0
			local cur_time = GetTime()
			for k,v in pairs(unitThrottle) do			
				if v <= cur_time then
					if UnitExists(k) then
						if ( unitThrottle[k] < cur_time ) then
							unitThrottle[k] = cur_time+options.unitThrottleValue		
							SPTimers.GetUnitDebuffs(k, "OnUpdate")
						end
					end
				end
			end
		end
	end

	function SPTimers:PLAYER_FOCUS_CHANGED()
		if UnitExists("focus") then
			SPTimers.GetUnitDebuffs("focus", "PLAYER_FOCUS_CHANGED")
		end
		
		self:UpdateTargetBars()
	end

	local lastGUID = nil
	function SPTimers:PLAYER_TARGET_CHANGED()
		for k,v in pairs(SPTimers.Anchors) do
			wipe(v.groups.target)
		end

		if UnitExists("target") then
			SPTimers.GetUnitDebuffs("target", "PLAYER_TARGET_CHANGED")
			SPTimers:MouseOverOnUpdate()
			self.myTarget = UnitGUID("target")
		else
			self.lastmyTarget = self.myTarget		
			self.myTarget = nil
		end
			
		self:UpdateTargetBars()
	end

	function SPTimers:UPDATE_MOUSEOVER_UNIT()
		if UnitExists("mouseover") then
			
			SPTimers.GetUnitDebuffs("mouseover", "UPDATE_MOUSEOVER_UNIT")
			SPTimers:MouseOverOnUpdate()
		end
	end

	local playerThrottle = 0
	local playerAuras = {
		["CLEU"] = 1,
		["ENCHANT"] = 1,
		["CHANNEL"] = 1,
		["TOTEM"] = 1,
		["TEST_BAR"] = 1,
	}
		
	function SPTimers:UNIT_AURA(event, unit)
		local curtime = GetTime()	
		if buffUnits[unit] then
			if curtime > playerThrottle then
				if options.bar_module_enabled then
					for _,anchor in pairs(SPTimers.Anchors) do
						for timer in pairs(anchor.active) do					
							if timer.targetGUID == self.myGUID and not playerAuras[timer.sourceFunc] then
								timer.updated = false
							end
						end
					end
				end
				playerThrottle = curtime+options.playerThrottleValue	
				SPTimers.GetUnitBuffs(unit, event)
				
				if options.bar_module_enabled then
					for _,anchor in pairs(SPTimers.Anchors) do
						local a = 0
						for timer in pairs(anchor.active) do
							if timer.targetGUID == self.myGUID and 
							not playerAuras[timer.sourceFunc] and
							not timer.updated then
								if SPTimers:IsSeveralAuras(timer.spellID) then
									timer:EndTimer()
								else							
									timer:EndTimer("play")
								end
								
							--	print(timer, "EndTimer", timer.spellName)
								a = a + 1
							end
						end
						if a > 0 then anchor:SortTimers("Unit Aura - remove player auras") end
					end
				end
			end
		elseif unitThrottle[unit] and options.bar_module_enabled then
			if unitThrottle[unit] < curtime then
				unitThrottle[unit] = curtime+options.unitThrottleValue
				SPTimers.GetUnitDebuffs(unit, event)
			end
		end
	end
	
	function OnlyMineFilter(unit, skip)
		if unit and UnitIsUnit(unit, "player") then 
			return true 
		end
		return false	
	end
	
	local playerFilter = { "HARMFUL", "HELPFUL" }
	
	local SeveralAuras = {}
	
	function SPTimers.GetUnitBuffs(unit, event)  -- for player and his pet only
	--	print(GetTime(), "GetUnitBuffs", unit, event)
		destGUID, sourceGUID, targetName, sourceName = nil, nil, nil, nil		
		
		wipe(SeveralAuras)
		for _, typeFilter in ipairs(playerFilter) do
			local i=1
			
			local auraType = typeFilter == "HELPFUL" and "BUFF" or "DEBUFF"			
			local filter_type = ( auraType == "BUFF" and 2 or 3 )
			
			local sourceFunc = "PLAYER_AURA"
			
			while true do
				local skip = false
				local showticks = false
				
				local name, _, icon, amount, debuffType, duration, endTime, sUnit, _, _, spellID = UnitAura(unit, i, typeFilter)
				if name then
					i=i+1
					
					if SPTimers:GetInternalCD(name, spellID) then
						local icd = SPTimers:GetICD(name, spellID)
						if icd > 0 and ( endTime ~= 0 and duration ~= 0 ) then
							icd = icd + endTime - duration
							SPTimers.NewCooldown(name, icon, icd, "INTERNAL_CD")
						end
					end

					skip = SPTimers:GetWhiteListFilter(spellID, filter_type, skip)
					skip = SPTimers:GetBlackListFilter(spellID, filter_type, skip)
					skip = SPTimers:GetProcsFilter(spellID, filter_type, skip)
					skip = SPTimers:GetOthersFilter(spellID, filter_type, skip)
					
					
					if skip then skip = SPTimers:CheckUnitSource(sUnit, SPTimers:GetAffiliation(spellID)) end
					
					if skip then
				
						if sUnit and UnitExists(sUnit) then 
							sourceGUID = UnitGUID(sUnit)
							sourceName = UnitName(sUnit)						
						end
					
						if spellID == 114207 or spellID == 114206 then
							if SPTimers.skullBanners[sourceGUID] and SPTimers.skullBanners[sourceGUID] > GetTime() then
								endTime = SPTimers.skullBanners[sourceGUID]
								duration = 10
							else
								endTime = 0
								duration = 0
							--	print("Not found", sourceGUID, SPTimers.skullBanners[sourceGUID], GetTime() ( SPTimers.skullBanners[sourceGUID] > GetTime() ))
							end
						elseif spellID == 120668 then
							if SPTimers.stormlash[sourceGUID] and SPTimers.stormlash[sourceGUID] > GetTime() then
								endTime = SPTimers.stormlash[sourceGUID]
								duration = 10
							else
								endTime = 0
								duration = 0
							end
						end

						if SPTimers:IsSeveralAuras(spellID) then
							SeveralAuras[spellID] = SeveralAuras[spellID] and SeveralAuras[spellID]+1 or 1
						end
						
						if SPTimers:GetCLEUSpellInfo(spellID) then showticks = true end
						
						local anchor = SPTimers:GetAnchor(spellID, destGUID)
				
						if rBuff then 
							local f = SPTimers.Anchors[anchor]:GetTimer(SPTimers.myGUID, spellID, nil, auraType)										
							if f then
								if f.endTime < endTime then									
									f:SetTimer(duration,endTime,name,spellID,icon,auraType,amount,SPTimers.myGUID,sourceGUID,unit,sUnit,SPTimers.myNAME,sourceName,GetRaidTargetIndex(unit),sourceFunc, showticks, nil, i)
								end
							else								
								SPTimers.Anchors[anchor]:ActivateTimerSkip(duration,endTime,name,spellID,icon,auraType,amount,SPTimers.myGUID,sourceGUID,unit,sUnit,SPTimers.myNAME,sourceName,GetRaidTargetIndex(unit),sourceFunc, showticks, nil, i)
							end
						else
						--	print(SPTimers:IsSeveralAuras(spellID), SeveralAuras[spellID], duration, endTime)
							SPTimers.Anchors[anchor]:ActivateTimer(duration,endTime,name,spellID,icon,auraType,amount,SPTimers.myGUID,sourceGUID,unit,sUnit,SPTimers.myNAME,sourceName,GetRaidTargetIndex(unit),sourceFunc, showticks, SeveralAuras[spellID], i)
						end					
					end
				else
					break
				end
			end
		end	
	end
	
	local debuffUnits = {
		target = 1,
		focus = 1,
		pettarget = 1,
		mouseover = 1,
        boss1 = 1,
        boss2 = 1,
		boss3 = 1,
		boss4 = 1,
		boss5 = 1,
        arena1 = 1,
        arena2 = 1,
        arena3 = 1,
        arena4 = 1,
        arena5 = 1,
	}
	
	function SPTimers.GetUnitDebuffs(unit, event)		
		destGUID, sourceGUID, targetName, sourceName = nil, nil, nil, nil
		
		if not debuffUnits[unit] then return end
		if not UnitCanAttack("player", unit) then return end

		destGUID = UnitGUID(unit)
		
		if not destGUID then return end
		
		local auraType, sourceFunc = "DEBUFF", "UNIT_DEBUFF"
		
		if not SPTimers:UnitFilter_UNIT(unit) then return end
		
		if unit ~= "target" then 
			if UnitExists("target") and UnitIsUnit(unit, "target") then return end	
			if unit ~= "focus" and UnitExists("focus") and UnitIsUnit(unit, "focus") then return end
		end
		
		
		targetName = UnitName(unit)

		for _,anc in pairs(SPTimers.Anchors) do
			for timer in pairs(anc.active) do	
				if timer.targetGUID == destGUID and not playerAuras[timer.sourceFunc] then
					timer.updated = false
				end
			end
		end		
		
		
		local i=1
		while true do
			local skip = false
			local showticks = false
				
			local name, _, icon, amount, debuffType, duration, endTime, sUnit, _, _, spellID = UnitDebuff(unit, i)
			if name then
				i=i+1

				skip = SPTimers:GetOthersFilter(spellID, 3, skip)
				skip = SPTimers:GetWhiteListFilter(spellID, 3, skip)
				skip = SPTimers:GetBlackListFilter(spellID, 3, skip)
				if SPTimers:IsChanneling(spellID) then skip = false end						
				if skip then skip = SPTimers:CheckUnitSource(sUnit, SPTimers:GetAffiliation(spellID)) end
				if unit == "target" then skip = SPTimers:GetRaidDebuffListFilter(spellID, skip) end
						
				if skip then
					if sUnit and UnitExists(sUnit) then 
						sourceGUID = UnitGUID(sUnit)	
						sourceName = UnitName(sUnit)
					end
						
					local anchor = SPTimers:GetAnchor(spellID, destGUID)
					local offtarget_a = SPTimers:GetOffAnchor(spellID, destGUID) 
					
					if offtarget_a and anchor ~= offtarget_a and unit ~= "target" then
						anchor = offtarget_a
					end
					
				--	print(anchor, offtarget_a, spellID)
			
					if SPTimers:GetCLEUSpellInfo(spellID) then showticks = true end
	
					if SPTimers:GetRaidDebuffListFilter(spellID) then
						local f
							
						for k,v in ipairs(SPTimers:GetRaidDebuffList(spellID)) do						
							f = SPTimers.Anchors[anchor]:GetTimer(destGUID, v, nil, auraType)
							if f then break end
						end

						
						if f then
							if f.endTime < endTime then
								f:SetTimer(duration,endTime,name,spellID,icon,auraType,amount,destGUID,sourceGUID,unit,sUnit,targetName,sourceName,GetRaidTargetIndex(unit),sourceFunc, showticks, nil, i)
							end
						else
							SPTimers.Anchors[anchor]:ActivateTimerSkip(duration,endTime,name,spellID,icon,auraType,amount,destGUID,sourceGUID,unit,sUnit,targetName,sourceName,GetRaidTargetIndex(unit),sourceFunc, showticks, nil, i)
						end
					else
						SPTimers.Anchors[anchor]:ActivateTimer(duration,endTime,name,spellID,icon,auraType,amount,destGUID,sourceGUID,unit,sUnit,targetName,sourceName,GetRaidTargetIndex(unit),sourceFunc, showticks, nil, i)	
					end
				end
			else
				break
			end
		end
		do
			for _,anc in pairs(SPTimers.Anchors) do
				local a = 0
				for timer in pairs(anc.active) do					
					if timer.targetGUID == SPTimers.myGUID and 
					not playerAuras[timer.sourceFunc] and
					not timer.updated then
						a = a + 1
						timer:EndTimer("play")
					end
				end
				if a > 0 then anc:SortTimers("GetUnitDebuffs - remove debuff") end
			end
		end
	end
end


do
	local string_match = string.match
	function SPTimers.Erase(name)
		if not name then return name end
		local rname = string_match(name, "(.+)-") or name
		return rname
	end
end

do
	
	local flagtort = {
		[COMBATLOG_OBJECT_NONE] = 0,
		[COMBATLOG_OBJECT_RAIDTARGET8] = 8,
		[COMBATLOG_OBJECT_RAIDTARGET7] = 7,
		[COMBATLOG_OBJECT_RAIDTARGET6] = 6,
		[COMBATLOG_OBJECT_RAIDTARGET5] = 5,
		[COMBATLOG_OBJECT_RAIDTARGET4] = 4,
		[COMBATLOG_OBJECT_RAIDTARGET3] = 3,
		[COMBATLOG_OBJECT_RAIDTARGET2] = 2,
		[COMBATLOG_OBJECT_RAIDTARGET1] = 1,
	}
		

	SPTimers.dots = {}
	local dots = SPTimers.dots
	
	SPTimers.skullBanners = {}
	local skullBanners = SPTimers.skullBanners
	
	SPTimers.stormlash = {}
	local stormlash = SPTimers.stormlash
	
	local AllowedEvent = {
		[120668] = "SPELL_CAST_SUCCESS",
		[114207] = "SPELL_CAST_SUCCESS",
		[33076] = "SPELL_CAST_SUCCESS",
	}
	
	local truedEvents = {
		SPELL_CAST_SUCCESS = 1,
		SPELL_AURA_REFRESH = 1,
		SPELL_AURA_APPLIED_DOSE = 1,
		SPELL_AURA_APPLIED = 1,
		SPELL_AURA_REMOVED = 1,
		SPELL_AURA_REMOVED_DOSE = 1,
		SPELL_SUMMON = 1,
		SPELL_ENERGIZE = 1,
	}
	
	function SPTimers:GetTickInfo(spellID, destGUID)
	
		local tick, hasted, pandemia = self:GetCLEUSpellInfo(spellID)

		if not tick then return end
		
		local haste = UnitSpellHaste("player")

		local tick_every = 0
		
		if hasted then
			tick_every	= tick/(1+(haste/100))
		else
			tick_every	= tick
		end

		dots[spellID..destGUID] = tick_every
		
	--	print("SPTimers:GetTickInfo", tick, hasted, pandemia, tick_every, dots[spellID..destGUID])
	end

	local TYPE_PLAYER = COMBATLOG_OBJECT_TYPE_PLAYER
	local TYPE_NPC	  = COMBATLOG_OBJECT_TYPE_NPC
	
	local function IsPlayer(flag)
		if flag and ( bit.band(flag, TYPE_PLAYER) > 0 ) then return true end
		return false
	end
	
	local function IsNPC(flag)
		if flag and ( bit.band(flag, TYPE_NPC) > 0 ) then return true end
		return false
	end
	
	function SPTimers:COMBAT_LOG_EVENT_UNFILTERED(event, timestamp, eventType, hideCaster,
					srcGUID, srcName, srcFlags, srcFlags2,
					dstGUID, dstName, dstFlags, dstFlags2,
					spellID, spellName, spellSchool, auraType, amount, extraSchool, extraType)
			
			local anchor, endTime, showticks, sourceFunc  = 1, nil, false, "CLEU"
			local name, stacks, duration, unitCaster, debuffType
			
			if eventType == "UNIT_DIED" or eventType == "UNIT_DESTROYED" or eventType == "SPELL_INSTAKILL" then
				self.targetEngaged[dstGUID] = nil
				return self:RemoveTimers(dstGUID, nil, true)
			end
			
			if not truedEvents[eventType] then return end
			
			if AllowedEvent[spellID] and AllowedEvent[spellID] == eventType then
				if spellID == 120668 then -- stormlash
					stormlash[srcGUID] = GetTime()+10.5
				elseif spellID == 114207 then -- skullbanners
					skullBanners[srcGUID] = GetTime()+10.5
				elseif spellID == 33076 then
					self:RemoveTimersBySourceGUID(41635, srcGUID, true)
				end
			end

			if srcGUID ~= self.myGUID and srcGUID ~= self.petGUID then return end
	
			local unit = srcGUID == self.petGUID and "pet" or "player"
			dstName = dstName or spellName or srcName or ""
			
			if eventType == "SPELL_CAST_SUCCESS" then 
				auraType = "SPELL_CAST"	
			elseif eventType == "SPELL_SUMMON" then
				auraType = "SPELL_SUMMON"
			elseif eventType == "SPELL_ENERGIZE" then
				auraType = "SPELL_ENERGIZE"
			end
			
			
			if not self:GetCLEUFilter(spellID, auraType) then return end
			if self:IsChanneling(spellID) then return end		
			if not self:UnitFilter_GUID(dstGUID) then return end
			
			if self:GetCLEUSpellInfo(spellID) then showticks = true end
			
			anchor = SPTimers:GetAnchor(spellID, dstGUID)
			
			local offtarget_a = SPTimers:GetOffAnchor(spellID, dstGUID) 
			
			if offtarget_a and anchor ~= offtarget_a and dstGUID ~= SPTimers.myTarget then
				anchor = offtarget_a
			end
				
			local isplayer = IsPlayer(dstFlags)
			local icon = self:GetSpellIcon(spellID)
			
			local destName = isplayer and SPTimers.Erase(dstName) or dstName
			
		--	print(SPTimers:DoUnitAnchor(spellID), anchor, offtarget_a, SPTimers:FindUnitGUID(dstGUID))
		--[[
			new 			old
			1 duration,		duration
			2 endTime, 		name
			3 name, 		spellID
			4 spellID,		destGUID
			5 icon, 		sourceGUID
			6 aura_type,	unit
			7 count,		unitCaster
			8 destGUID, 	expirationTime
			9 sourceGUID, 	icon
			10 destUnit, 	count
			11 sourceUnit, 	doCLEU
			12 targetName, 	targetName
			13 sourceName,	sourceName
			14 raidIndex, 	raidIndex
			15 sourceFunc,	showticks
			16 showticks, 
			17 aura_number		
		]]
		--[[
		if self.sourceFunc == "CLEU" then
			local name, stacks, spellID, duration, endTime, unitCaster, debuffType = SPTimers:GuidAuraInfo(self.targetGUID, self.spellID, self.aura_type)
			
			if name then count = stacks end
		end
			]]
			if eventType == "SPELL_AURA_REFRESH" then
				if showticks then self:GetTickInfo(spellID, dstGUID) end
				
				local name, stacks, spell_id, duration, endTime_1, unitCaster, debuffType = SPTimers:GuidAuraInfo(dstGUID, spellID, auraType)
				
				return self.Anchors[anchor]:ActivateTimer(self:GetDuration(spellID, dstGUID, 2, isplayer),endTime,spellName,spellID,icon,auraType,stacks,dstGUID,srcGUID,nil,unit,destName,srcName,flagtort[dstFlags2],sourceFunc, showticks)
			elseif eventType == "SPELL_AURA_APPLIED_DOSE" then
				return self.Anchors[anchor]:AppliedDose(self:GetDuration(spellID, nil, nil, isplayer),endTime,spellName,spellID,icon,auraType,amount,dstGUID,srcGUID,nil,unit,destName,srcName,flagtort[dstFlags2],sourceFunc, showticks)
			elseif eventType == "SPELL_AURA_APPLIED" then
				
				local name, stacks, spell_id, duration, endTime_1, unitCaster, debuffType = SPTimers:GuidAuraInfo(dstGUID, spellID, auraType)
				
				if showticks then self:GetTickInfo(spellID, dstGUID) end
				return self.Anchors[anchor]:ActivateTimer(self:GetDuration(spellID, dstGUID, 1, isplayer),endTime,spellName,spellID,icon,auraType,stacks,dstGUID,srcGUID,nil,unit,destName,srcName,flagtort[dstFlags2],sourceFunc, showticks)
			elseif eventType == "SPELL_AURA_REMOVED" then
				self:RemovePandemia(spellID, dstGUID)
				
			--	print(eventType, srcName, spellID, spellName, dstName, dstGUID, srcGUID,auraType)
				
				return self:RemoveTimersGUID(dstGUID, spellID, srcGUID,auraType)
			elseif event == "SPELL_AURA_BROKEN" or event == "SPELL_AURA_BROKEN_SPELL" then
			
				print(eventType, srcName, spellID, spellName, dstName, dstGUID, srcGUID,auraType)
			elseif eventType == "SPELL_AURA_REMOVED_DOSE" then
				return self.Anchors[anchor]:AppliedDose(self:GetDuration(spellID),endTime,spellName,spellID,icon,auraType,amount,dstGUID,srcGUID,nil,unit,destName,srcName,flagtort[dstFlags2],sourceFunc, showticks)
			elseif eventType == "SPELL_SUMMON" then
				return self.Anchors[anchor]:ActivateTimer(self:GetDuration(spellID, nil, nil, isplayer),endTime,spellName,spellID,icon,auraType,amount,dstGUID,srcGUID,nil,unit,destName,srcName,flagtort[dstFlags2],sourceFunc, showticks)
			elseif eventType == "SPELL_CAST_SUCCESS" then
				if showticks then 									
					if not dstGUID then dstGUID = srcGUID end
					self:GetTickInfo(spellID, dstGUID) 
				end
				return self.Anchors[anchor]:ActivateTimer(self:GetDuration(spellID, nil, nil, isplayer),endTime,spellName,spellID,icon,auraType,amount,dstGUID,srcGUID,nil,unit,destName,srcName,flagtort[dstFlags2],sourceFunc, showticks)
			elseif eventType == "SPELL_ENERGIZE" then
				return self.Anchors[anchor]:ActivateTimer(self:GetDuration(spellID, nil, nil, isplayer),endTime,spellName,spellID,icon,auraType,amount,dstGUID,srcGUID,nil,unit,destName,srcName,flagtort[dstFlags2],sourceFunc, showticks)			
			end
	end
end
--[[
function SPTimers:UpdateStats()
	local mastery, haste, crit = GetMastery(), UnitSpellHaste("player"), GetSpellCritChance(6)

	self.myHaste = 1+(haste/100)
	return self.myHaste
end

]]
do

	local channel_spell = {}

	local function UpdateCannelInfo(haste, anchor, showticks, spellID)
		if haste then		
			SPTimers:GetTickInfo(spellID, "channel:spell")
		end
		
		local spell, _, displayName, icon, startTime, endTime, _, _, _ = UnitChannelInfo("player")
		
		if spell then
			local playerName = SPTimers.myNAME -- UnitName("player")
			local targetName = UnitName("target") or playerName
		
			SPTimers.Anchors[anchor]:ActivateTimer((endTime-startTime)/1000,endTime/1000,spell,spellID,icon,"CHANNEL",0,"channel:spell",SPTimers.myGUID,"player","player",targetName,playerName,GetRaidTargetIndex("target"),"CHANNEL", showticks)
		end
	end
	
	function SPTimers:ScanForChannelingSpell()
		for k,v in pairs(self.db.profile.classSpells[self.myCLASS]) do
			local spell = GetSpellInfo(k)
			if v.channel then				
				channel_spell[spell] = k
			else				
				if channel_spell[spell] and not v.channel then
					channel_spell[spell] = nil			
				end
			end
		end
	end
	
	function SPTimers:UNIT_SPELLCAST_CHANNEL_START(event,unit,spell,lineID,spellID)	
		if unit ~= "player" then return end

		local spellID = channel_spell[spell]		
		if not spellID then return end
		
		local anchor = self:GetAnchor(spellID)
		local showticks = self:GetCLEUSpellInfo(spellID)
		
	--	self.unitThrottle["target"] = 0
	--	self.unitThrottle["focus"] = 0
		
		self.GetUnitDebuffs("target", "UNIT_SPELLCAST_CHANNEL_START")
		
		local skip = false 
		
		skip = SPTimers:GetWhiteListFilter(spellID, "BUFF", skip)
		skip = SPTimers:GetBlackListFilter(spellID, "BUFF", skip)
			
		if skip then
			UpdateCannelInfo(true, anchor, showticks, spellID)
		end
	end
	
	function SPTimers:UNIT_SPELLCAST_CHANNEL_STOP(event,unit, spell, rank, lineID, spellID)
		if unit ~= "player" then return end
		
	--	print(event, unit, spell, spellID)
		--local spellID = channel_spell[spell]		
		--if not spellID then return end		
		if not SPTimers:IsChanneling(spellID) then return end
		
		local anchor = self:GetAnchor(spellID)
		
		self:RemoveTimersGUID("channel:spell", spellID, self.myGUID, nil, true)
	end

	function SPTimers:UNIT_SPELLCAST_CHANNEL_UPDATE(event,unit, spell, rank, lineID, spellID)
		if unit ~= "player" then return end
	--	local spellID = channel_spell[spell]		
	--	if not spellID then return end
		if not SPTimers:IsChanneling(spellID) then return end
		local anchor = self:GetAnchor(spellID)
		local showticks = self:GetCLEUSpellInfo(spellID)
		
	--	print(event, unit, spell, spellID)
		local skip = false 
		
		skip = SPTimers:GetWhiteListFilter(spellID, "BUFF", skip)
		skip = SPTimers:GetBlackListFilter(spellID, "BUFF", skip)
			
		if skip then
			UpdateCannelInfo(false, anchor, showticks, spellID)
		end
	end
	
	
	
	function SPTimers:UNIT_SPELLCAST_SENT(event,unit,spell,rank,target,lineID)
		if unit ~= "player" then return end
		
		--print(event, target)
		--	self.unitThrottle["target"] = 0
		--	self.unitThrottle["focus"] = 0
			
		self.GetUnitDebuffs("target", "UNIT_SPELLCAST_SENT")
	end
	
	function SPTimers:UNIT_SPELLCAST_START(event,unit,spell,rank,lineID,spellID) --"unitID", "spell", "rank", lineID, spellID
		if unit ~= "player" then return end
		--	self.unitThrottle["target"] = 0
		--	self.unitThrottle["focus"] = 0
		
		--print(event, target)
		self.GetUnitDebuffs("target", "UNIT_SPELLCAST_START")
	end
	
	function SPTimers:UNIT_SPELLCAST_SUCCEEDED(event,unit,spell,rank,lineID,spellID)
		if unit ~= "player" then return end
		
		--print(event, target)
		self.GetUnitDebuffs("target", "UNIT_SPELLCAST_SENT")
	end
	
	function SPTimers:UNIT_SPELLCAST_STOP(event,unit,spell,rank,lineID,spellID)
		if unit ~= "player" then return end
		
		--print(event, target)
	end
end

do
	local hidegametooltip = CreateFrame("Frame")
	hidegametooltip:Hide()
	local gametooltip = CreateFrame("GameTooltip", "SPTimersGameToolTip", nil, "GameTooltipTemplate"); -- Tooltip name cannot be nil	
	gametooltip:SetOwner( hidegametooltip,"ANCHOR_NONE");

	local tempEnchants = {
		
		[L["Earthliving"]] = 51730,
		[L["Flametongue"]] = 8024,
		[L["Frostbrand"]]  = 8033,
		[L["Rockbiter"]]   = 8017,
		[L["Windfury"]]    = 8232,
		
	}
	
	local match = string.match
	local GetInventorySlotInfo = GetInventorySlotInfo
	
	function SPTimers.GetEnchantID(slotName)
		local slot = GetInventorySlotInfo(slotName)
		
		gametooltip:ClearLines()
		
		if slot then 
			gametooltip:SetInventoryItem("player", slot)
			
			for i = 1, gametooltip:NumLines() do
				local line = _G[gametooltip:GetName().."TextLeft"..i]:GetText()
				for k, v in pairs(tempEnchants) do
					if match(line, k) then
						local a1, a2, a3 = GetSpellInfo(v)
						
						return v, a1, a3
					end
				end
			end
			
			return nil
		end
	end
	
	
	local GetWeaponEnchantInfo = GetWeaponEnchantInfo
	
	local select = select
	local function checkWeaponEnchant(has,left,count,name,slotName)
		if has then
			left = left*0.001;
			local num = 1
			local endTime = GetTime()+left;
			local spellID, name, icon = SPTimers.GetEnchantID(slotName)
			local anchor = SPTimers:GetAnchor(spellID)
			
			if slotName == "SecondaryHandSlot" then num = 2 end
			
			local icon = GetInventoryItemTexture("player",select(1,GetInventorySlotInfo(slotName)))
			
		--	print(name, endTime, left, spellID)
			
			SPTimers.Anchors[anchor]:ActivateTimer(3600,endTime,name,spellID,icon,"BUFF",0,SPTimers.myGUID,SPTimers.myGUID,"player","player",SPTimers.myNAME, SPTimers.myNAME,GetRaidTargetIndex("player"), "ENCHANT", nil, num)
		end
	end
	
	local pairs = pairs
	
	local lastUpdate = 0
	local loop = CreateFrame("Frame", "SPTimers-OnUpdateLoop:core")
	loop.elapsed = 0
	loop:Hide()
	loop:SetScript("OnUpdate", function(self, elapsed)
		self.elapsed = self.elapsed + elapsed
		
		local hasMainHandEnchant, mainHandExpiration, mainHandCharges, hasOffHandEnchant, offHandExpiration, offHandCharges = GetWeaponEnchantInfo();

		if self.elapsed > 0.25 or mainHandExpiration == 3600000 or offHandExpiration == 3600000 then
			SPTimers:ENCHANT_UPDATE()
			self.elapsed = 0
			self:Hide()
		end
	end)
	
	function SPTimers:UNIT_INVENTORY_CHANGED(event, unit)
		if unit ~= "player" then return end
		if not options.showenchants then return end
		
		local hasMainHandEnchant, mainHandExpiration, mainHandCharges, hasOffHandEnchant, offHandExpiration, offHandCharges = GetWeaponEnchantInfo();
		
	--	print("S", self.elapsed, mainHandExpiration, offHandExpiration)
		
		loop:Show()
	end
	
	function SPTimers:ENCHANT_UPDATE()
		for _,v in pairs(self.Anchors) do
			for f in pairs(v.active) do				
				if f.sourceFunc == "ENCHANT" then f.updated = false end
			end
		end
		
		local hasMainHandEnchant, mainHandExpiration, mainHandCharges, hasOffHandEnchant, offHandExpiration, offHandCharges = GetWeaponEnchantInfo();
		checkWeaponEnchant(hasMainHandEnchant,mainHandExpiration,mainHandCharges,"MainHand","MainHandSlot");
		checkWeaponEnchant(hasOffHandEnchant,offHandExpiration,offHandCharges,"OffHand","SecondaryHandSlot");
		
		for _,v in pairs(self.Anchors) do
			local a = 0
			for f in pairs(v.active) do				
				if f.sourceFunc == "ENCHANT" and not f.updated then f:EndTimer(); a = a + 1 end
			end
			if a > 0 then v:SortTimers("UNIT_INVENTORY_CHANGED - remove player enchant") end 
		end
	end
	
	function SPTimers:UpdateEnchants()
		if options.showenchants then
			self:RegisterEvent("UNIT_INVENTORY_CHANGED")
			self:UNIT_INVENTORY_CHANGED(nil, "player")			
		else
			self:UnregisterEvent("UNIT_INVENTORY_CHANGED")
			
			for _,v in pairs(self.Anchors) do
				for f in pairs(v.active) do				
					if f.sourceFunc == "ENCHANT" then f:EndTimer() end
				end
				v:SortTimers("UpdateEnchants - disable Enchants")
			end
		end
	end
end

function SPTimers:PLAYER_LOGIN()
	self.myGUID = UnitGUID("player")
	local _,class = UnitClass("player")	
	self.myCLASS = class
	self.myNAME = UnitName("player")
end

function SPTimers:UNIT_PET(event, unit)
	if unit == "player" then
		if UnitExists("pet") then
			self.petGUID = UnitGUID("pet")
		else
			self.petGUID = nil
		end
	end
end

do
	
	local totemsName = {}
	local totemItems = {5176, 5175, 5177, 5178 }
	
	-- 5176 -- Fire , 5175 -- Earth, 5178 -- Air , 5177 -- Water
	
	local function GetTotemFilter(i)
		
		if not totemsName[i] then
			totemsName[i] = GetItemInfo(totemItems[i])
		--	print("GetTotemFilter", totemsName[i])

		end
		
		return totemsName[i]
	end
	
	local loop = CreateFrame("Frame", "SPTimers-OnUpdateLoop2:core")
	loop.elapsed = 0
	loop:Hide()
	loop:SetScript("OnUpdate", function(self, elapsed)
		self.elapsed = self.elapsed + elapsed

		local alldone = true
		
		for i=1, MAX_TOTEMS do
			if GetTotemFilter(i) == nil then		
				alldone = false
			end
		end
		
		if alldone then
		--	print("Complete cache item in "..format("%.1f", self.elapsed).."s.")
			
			for i=1, MAX_TOTEMS do
				SPTimers:PLAYER_TOTEM_UPDATE(nil, i)
			end
			
			self.elapsed = 0
			self:Hide()
		end
	end)
	
	
	function SPTimers:UpdateTotems()
		if ( self.myCLASS == "SHAMAN" or self.myCLASS == "DRUID" ) then
			if ( self:ShowTotems("totem1") or self:ShowTotems("totem2") or self:ShowTotems("totem3") or self:ShowTotems("totem4") ) then
				self:RegisterEvent("PLAYER_TOTEM_UPDATE")
				loop:Show()
			end
		else	
			self:UnregisterEvent("PLAYER_TOTEM_UPDATE")
			for i=1, MAX_TOTEMS do
				SPTimers:PLAYER_TOTEM_UPDATE(nil, i, true)
			end
		end
	end
	
	function SPTimers:PLAYER_TOTEM_UPDATE(event, totem, rem)
--		print("PLAYER_TOTEM_UPDATE", totem)
		local anchor = self:GetAnchor("totem"..totem)
		local haveTotem, totemName, startTime, duration, icon = GetTotemInfo(totem)
		if not rem and self:ShowTotems("totem"..totem) and haveTotem and ( GetTotemFilter(totem) ~= totemName )then
			self.Anchors[anchor]:ActivateTimer(duration,startTime+duration,totemName,"totem"..totem,icon,"BUFF",0,self.myGUID,self.myGUID,"player","player",self.myNAME, self.myNAME,0, "TOTEM")
		else
			local f = self.Anchors[anchor]:GetTimer(self.myGUID,"totem"..totem, self.myGUID,"BUFF")	
			if f then f:EndTimer(); self.Anchors[anchor]:SortTimers("PLAYER_TOTEM_UPDATE - Remove Totems") end
		end
	end
end

do
	local delayupdate = CreateFrame("Frame", "SPTimers-DelayUpdate:core", UIParent)
	delayupdate.elapsed = 0
	delayupdate.updates = {}
	delayupdate:Show()
	delayupdate:SetScript("OnUpdate", function(self, elapsed)
		self.elapsed = self.elapsed + elapsed
		
		if self.elapsed < 1 then return end
		
		for _,func in pairs(self.updates) do
			func()
		end
		
		wipe(self.updates)
		self:Hide()
	end)

	function SPTimers:PlayerLoginDelay(func)
		if type(func) == "function" then	
			table.insert(delayupdate.updates, func)
		end
	end
end

function SPTimers:CoreBarsStatusUpdate()
	if options.bar_module_enabled then
		
		self:RegisterEvent("PLAYER_TARGET_CHANGED")
		self:RegisterEvent("PLAYER_FOCUS_CHANGED")
		self:RegisterEvent("UPDATE_MOUSEOVER_UNIT")
		self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		self:RegisterEvent("UNIT_INVENTORY_CHANGED")
		self:RegisterEvent("UNIT_SPELLCAST_CHANNEL_START")
		self:RegisterEvent("UNIT_SPELLCAST_CHANNEL_STOP")
		self:RegisterEvent("UNIT_SPELLCAST_CHANNEL_UPDATE")
		self:RegisterEvent("UNIT_SPELLCAST_SENT")
		self:RegisterEvent("UNIT_SPELLCAST_START")
		self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
		self:RegisterEvent("UNIT_SPELLCAST_STOP")
		self.checkUnitOnUpdate:SetScript("OnUpdate", self.checkUnitOnUpdateFunc)
	else
		self:UnregisterEvent("PLAYER_TARGET_CHANGED")
		self:UnregisterEvent("PLAYER_FOCUS_CHANGED")
		self:UnregisterEvent("UPDATE_MOUSEOVER_UNIT")
		self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		self:UnregisterEvent("UNIT_INVENTORY_CHANGED")
		self:UnregisterEvent("UNIT_SPELLCAST_CHANNEL_START")
		self:UnregisterEvent("UNIT_SPELLCAST_CHANNEL_STOP")
		self:UnregisterEvent("UNIT_SPELLCAST_CHANNEL_UPDATE")
		self:UnregisterEvent("UNIT_SPELLCAST_SENT")
		self:UnregisterEvent("UNIT_SPELLCAST_START")		
		self:UnregisterEvent("PLAYER_TOTEM_UPDATE")
		self:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED")
		self:UnregisterEvent("UNIT_SPELLCAST_STOP")
		self.checkUnitOnUpdate:SetScript("OnUpdate", nil)
	end
end

function SPTimers:UpdateMinimap() 
	if options.minimap.hide then
		minimap_icon:Show("SPTimers Minimap")
	else
		minimap_icon:Hide("SPTimers Minimap")
	end
end


local forced = true
function SPTimers:CheckDebugging()
	
	local _, battleTag = BNGetInfo()
	local myBTag = GetAddOnMetadata("SPTimers", "Author")
	
	if battleTag then
		if myBTag == battleTag and forced then 
			self.dodebugging = true
			message("DEBUGGING ON")
		end
		
	--	self:UnregisterEvent("PLAYER_ENTERING_WORLD")
		self:UnregisterEvent("BN_CONNECTED")
		self:UnregisterEvent("BN_SELF_ONLINE")
		self:UnregisterEvent("BN_INFO_CHANGED")
	end
end

SLASH_SPTIMERSDEBUG1 = '/sptimersdebugging'
function SPTIMERSDEBUGHandler(msg, editBox)
	SPTimers.dodebugging = not SPTimers.dodebugging
	
	message( (SPTimers.dodebugging and "DEBUGGING ON" or "DEBUGGING OFF" ) )
end

SlashCmdList["SPTIMERSDEBUG"] = SPTIMERSDEBUGHandler

do
	local raid = {}
	
	local IsInRaid, IsInGroup = IsInRaid, IsInGroup
	local inraid = false
	local format = format
	local wipe = wipe
	local UnitExists = UnitExists
	local GetNumGroupMembers, GetNumSubgroupMembers = GetNumGroupMembers, GetNumSubgroupMembers
	local UnitAura, GetSpellInfo = UnitAura, GetSpellInfo
	
	local function LeaveFromRaidOrGroup()
		if not IsInRaid() then
			if inraid then inraid = false; wipe(raid) end
		elseif IsInRaid() then
			if not inraid then inraid = true end
		end
	end
	
	local function CheckUnit(unit)
		if not UnitExists(unit) then return end	
		local guid = UnitGUID(unit)
		if not guid then return end

		raid[guid] = unit
		
	--	print(raid[guid], guid, unit)
	end
	
	function SPTimers:GetRaidGUID(guid)		
		return raid[guid]
	end
	
	local auratypes = {
		['DEBUFF']	= 'HARMFUL',
		['BUFF']	= 'HELPFUL',
		['HARMFUL'] = 'HARMFUL',
		['HELPFUL'] = 'HELPFUL',
	}
	
	function SPTimers:GuidAuraInfo(guid, spell, auratype)
		if not raid[guid] then return end

		local spellname = type(spell) == "number" and GetSpellInfo(spell) or spell
		
		local name, _, _, count, debuffType, duration, endTime, unitCaster, _, _, spellID = UnitAura(raid[guid], spellname, nil, auratypes[auratype])
		
	--	print("GuidAuraInfo", guid, spell, auratype, name, auratypes[auratype])
		if name and ( spellname == name or spell == spellID ) then		
			return name, count, spellID, duration, endTime, unitCaster, debuffType
		end
		
		return nil
	end
	
	function SPTimers:UpdateRaid()
		wipe(raid)

		LeaveFromRaidOrGroup()
		
		if IsInRaid() then
		  for i = 1, GetNumGroupMembers() do
			CheckUnit(format("raid%d", i))
		  end
		end
		
		if IsInGroup() and not IsInRaid() then
		  for i = 1, GetNumSubgroupMembers() do
			CheckUnit(format("party%d", i))
		  end
		end
		
		CheckUnit("player")
	end
end

do
	local isInPetBattle = C_PetBattles.IsInBattle;
	function SPTimers:PET_BAR_UPDATE()
--		print("SPTimers:PET_BAR_UPDATE", isInPetBattle())		
		if ( options.hide_during_petbattle and isInPetBattle() ) then 
			parent:Hide() 
		else 
			parent:Show() 
		end
	end
end

local LSM_Update = CreateFrame("Frame", "SPTImers-LSM_OnUpdate:core")
LSM_Update:Hide()
LSM_Update:SetScript("OnUpdate", function(self, elapsed)
	self.elapsed = ( self.elapsed or 0 ) + elapsed
	
	if self.elapsed < 0.1 then return end
	
	SPTimers:Visibility()
	SPTimers.UpdateSettings()
	
--	print("update visual2")
	
	self:Hide()
	self.elapsed = 0
end)
SPTimers.SharedMedia.RegisterCallback(LSM_Update, "LibSharedMedia_Registered", function(mtype, key)
--	print("update visual1")
	LSM_Update:Show();	
end)
	
function SPTimers:OnInitialize()

	self.myGUID = UnitGUID("player")

	local _,class = UnitClass("player")	
	self.myCLASS = class
	self.petGUID = UnitGUID("pet")
	self.myNAME = UnitName("player")
	
	self.myHaste = 1
	
	self:DefaultOptions()
	
	self.db.RegisterCallback(self, "OnProfileChanged", "OnProfileChange")
    self.db.RegisterCallback(self, "OnProfileCopied", "OnProfileChange")
    self.db.RegisterCallback(self, "OnProfileReset", "OnProfileChange")

	
	
	self.options = self:OptionsTable()
	
	if self.SetupClassOptions then
		self:SetupClassOptions()
	end

	self:InitSupports()
	
    LibStub('LibDualSpec-1.0'):EnhanceDatabase(self.db, "SPTimers")
    LibStub('LibDualSpec-1.0'):EnhanceOptions(self.options.args.profile, self.db)
	LibStub("AceConfig-3.0"):RegisterOptionsTable("SPTimers", self.options)
	
	options = self.db.profile
	
	minimap_icon:Register("SPTimers Minimap", SPTimersLDB, options)
	
	self:InitFrames()
	self:InitCooldownLine()
	
	self:RegisterEvent("UNIT_AURA")

	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")

	self:RegisterEvent("BN_CONNECTED", "CheckDebugging")
	self:RegisterEvent("BN_SELF_ONLINE", "CheckDebugging")
	self:RegisterEvent("BN_INFO_CHANGED", "CheckDebugging")
	
	self:RegisterEvent("PLAYER_LOGIN")
	
	self:PlayerLoginDelay(function() SPTimers:UpdateEnchants() end)
	self:PlayerLoginDelay(function() SPTimers:UpdateTotems() end)
	self:PlayerLoginDelay(function() SPTimers:UpdateMinimap() end)
	
	self:RegisterEvent("GROUP_ROSTER_UPDATE", "UpdateRaid")
	self:RegisterEvent("PLAYER_ENTERING_WORLD", "UpdateRaid")
	self:RegisterEvent("PLAYER_ENTERING_BATTLEGROUND", "UpdateRaid")
	self:RegisterEvent("GROUP_JOINED", "UpdateRaid")
	self:RegisterEvent("RAID_INSTANCE_WELCOME", "UpdateRaid")
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA", "UpdateRaid")
	
	self:RegisterEvent("PET_BAR_UPDATE")
	self:RegisterEvent("PET_BATTLE_OPENING_START", "PET_BAR_UPDATE")
	self:RegisterEvent("PET_BATTLE_OPENING_DONE", "PET_BAR_UPDATE")
	self:RegisterEvent("PET_BATTLE_CLOSE", "PET_BAR_UPDATE")
	self:RegisterEvent("PET_BATTLE_OVER", "PET_BAR_UPDATE")

	
	
	self:RegisterEvent("UNIT_PET")
	
	self:ScanForChannelingSpell()
	self:RebuildBanCD()
	self:CoreBarsStatusUpdate()
	self:CheckDebugging()
end

function SPTimers:OnProfileChange()
	
	self.onUpdateHandler:SetScript("OnUpdate", nil)
	
	self.myGUID = UnitGUID("player")

	local _,class = UnitClass("player")	
	self.myCLASS = class
	self.petGUID = UnitGUID("pet")
	self.myNAME = UnitName("player")

	self:DefaultOptions()
	
	self.db.RegisterCallback(self, "OnProfileChanged", "OnProfileChange")
    self.db.RegisterCallback(self, "OnProfileCopied", "OnProfileChange")
    self.db.RegisterCallback(self, "OnProfileReset", "OnProfileChange")
	
	self.options = self:OptionsTable()
	
	if self.SetupClassOptions then
		self:SetupClassOptions()
	end

	self:InitSupports()
	
    LibStub('LibDualSpec-1.0'):EnhanceDatabase(self.db, "SPTimers")
    LibStub('LibDualSpec-1.0'):EnhanceOptions(self.options.args.profile, self.db)
	LibStub("AceConfig-3.0"):RegisterOptionsTable("SPTimers", self.options)
	
	options = self.db.profile

	self:InitFrames()
	self:InitCooldownLine()
	
	self:RegisterEvent("UNIT_AURA")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("PLAYER_LOGIN")
	self:RegisterEvent("GROUP_ROSTER_UPDATE", "UpdateRaid")
	self:RegisterEvent("PLAYER_ENTERING_WORLD", "UpdateRaid")
	self:RegisterEvent("PLAYER_ENTERING_BATTLEGROUND", "UpdateRaid")
	self:RegisterEvent("GROUP_JOINED", "UpdateRaid")
	self:RegisterEvent("RAID_INSTANCE_WELCOME", "UpdateRaid")
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA", "UpdateRaid")
	self:RegisterEvent("UNIT_PET")

	self:RebuildBanCD()
	self:CheckDebugging()
	self:UpdateMinimap() 
	self:ScanForChannelingSpell()	
	self:CoreBarsStatusUpdate()
	self:UpdateEnchants()
	self:UpdateTotems()
end

do
	local mover_frames = {}
	local function createbutton(parent, name)
		if not parent.buttons then parent.buttons = {} end
		
		local f = CreateFrame("Button", parent:GetName().."Button"..#parent.buttons+1, parent)
		f:SetFrameLevel(parent:GetFrameLevel() + 1)
		f.parent = parent
		f:SetText(name)
		f:SetWidth(20) --ширина
		f:SetHeight(20) --высота
		f:SetNormalFontObject("GameFontNormalSmall")
		f:SetHighlightFontObject("GameFontHighlightSmall")
		f:SetBackdrop({
				bgFile = [=[Interface\ChatFrame\ChatFrameBackground]=],
				edgeFile = [=[Interface\ChatFrame\ChatFrameBackground]=],
				edgeSize = 1,
				insets = {top = 0, left = 0, bottom = 0, right = 0},
					})
		f:SetBackdropColor(0,0,0,1)
		f:SetBackdropBorderColor(.3,.3,.3,1)
		
		f:SetScript("OnEnter", function(self)
				self:SetBackdropBorderColor(1,1,1,1) --цвет краев
			end)
			f:SetScript("OnLeave", function(self)
				self:SetBackdropBorderColor(.3,.3,.3,1) --цвет краев
			end)
			
		local t = f:GetFontString()
		t:SetFont("Fonts\\ARIALN.TTF", 12, "OUTLINE")
		t:SetJustifyH("CENTER")
		t:SetJustifyV("CENTER")
		f.text = t
		
		return f
	end
	
	local function createeditboxe(parent)
		if not parent.editboxes then parent.editboxes = {} end
		local textbox = CreateFrame("EditBox", parent:GetName().."EditBox"..#parent.editboxes+1, parent)
		textbox:SetFont("Fonts\\ARIALN.TTF", 12, "OUTLINE")
		textbox:SetFrameLevel(parent:GetFrameLevel() + 1)
		textbox:SetAutoFocus(false)
		textbox:SetWidth(50)
		textbox:SetHeight(20)
		textbox:SetJustifyH("LEFT")
		textbox:SetJustifyV("CENTER")
		textbox:SetBackdrop({
				bgFile = [=[Interface\ChatFrame\ChatFrameBackground]=],
				edgeFile = [=[Interface\ChatFrame\ChatFrameBackground]=],
				edgeSize = 1,
				insets = {top = 0, left = 0, bottom = 0, right = 0},
					})
		textbox:SetBackdropColor(0,0,0,1)
		textbox:SetBackdropBorderColor(1,1,1,0.5)
		
		textbox.ok = createbutton(textbox, "OK")
		textbox.ok.editbox = textbox
		textbox.ok.text:SetFont("Fonts\\ARIALN.TTF", 10, "OUTLINE")
		textbox.ok:SetSize(15,15)
		textbox.ok:SetPoint("RIGHT", textbox, "RIGHT", -2, 0)
		textbox.ok:Hide()
		
		textbox:SetScript("OnEscapePressed", function(self)
			self:ClearFocus()
		end)
		textbox:SetScript("OnEnterPressed", function(self)
			self.ChangePosition(self.ok)
		end)
		return textbox
	end
	
	local buttons_name = { "◄", "▲", "▼", "►" }
	local buttons_move = { { -1, 0 } , { 0, 1 }, { 0, -1} , { 1, 0} }
	
	function SPTimers:UpdateMoverPosition()
		for k,v in pairs(mover_frames) do
			k:UpdatePoint()
		end
	end
	

	function SPTimers.AddMoverButtons(self, opts, tip, tomover, float)
		if not self.mover_add_button then			
			self.mover_add_button = CreateFrame("Frame", self:GetName().."MoverToolTip", self)
			self.mover_add_button.mover = self
			self.mover_add_button.opts = opts
			self.mover_add_button.tip = tip
			self.mover_add_button.tomover = tomover
			self.mover_add_button.float = float
			self.mover_add_button.buttons = {}
			self.mover_add_button.editboxes = {}
			self.mover_add_button:SetSize(120, 70)
			self.mover_add_button:SetClampedToScreen(true)
			self.mover_add_button:SetBackdrop({bgFile = "Interface\\ChatFrame\\ChatFrameBackground",})	
			self.mover_add_button:SetBackdropColor(0, 0, 0, 0.7)
			self.mover_add_button:Show()
			self.mover_add_button.UpdatePoint = function(self)
				
				self:ClearAllPoints()
				
				if self.tomover then
					self:SetPoint("TOP", self.mover, "TOP",0,-3)
					self:SetBackdropColor(0, 0, 0, 0)
				else
					if self.opts and not self.opts.add_up then
						self:SetPoint("BOTTOM", self.mover, "TOP",0, 3)
					else
						self:SetPoint("TOP", self.mover, "BOTTOM",0,-3)
					end
				end
				
				if options.show_more_buttons then 
					self:Show()
				else
					self:Hide()
				end
				
				for k,v in pairs(self.editboxes) do
					v:UpdateText()
				end
			end
			
			mover_frames[self.mover_add_button] = true
			
			for i=1,4 do				
				self.mover_add_button.buttons[i] = createbutton(self.mover_add_button, buttons_name[i])
				self.mover_add_button.buttons[i].i = i
				self.mover_add_button.buttons[i].owner = self.mover_add_button
				
				if i == 1 then
					self.mover_add_button.buttons[i]:SetPoint("TOPRIGHT", self.mover_add_button, "TOP", 0, -3)
				elseif i == 2 then
					self.mover_add_button.buttons[i]:SetPoint("TOPRIGHT", self.mover_add_button, "TOP", -21, -3)
				elseif i == 3 then
					self.mover_add_button.buttons[i]:SetPoint("TOPLEFT", self.mover_add_button, "TOP", 0, -3)
				elseif i == 4 then
					self.mover_add_button.buttons[i]:SetPoint("TOPLEFT", self.mover_add_button, "TOP", 21, -3)
				end
				
				self.mover_add_button.buttons[i]:SetScript("OnClick", function(self)
					
					if self.owner.opts then
						self.owner.opts.point[1] = (tonumber(self.owner.opts.point[1]) or 0) + buttons_move[self.i][1]
						self.owner.opts.point[2] = (tonumber(self.owner.opts.point[2]) or 0) + buttons_move[self.i][2]
						
						self.owner.mover:ClearAllPoints()
						self.owner.mover:SetPoint("CENTER", parent, "CENTER", self.owner.opts.point[1], self.owner.opts.point[2] )
					elseif self.owner.tip and self.owner.tip == "line" then
					
						SPTimers.db.profile.cooldownline.x = (tonumber(SPTimers.db.profile.cooldownline.x) or 0) + buttons_move[self.i][1]
						SPTimers.db.profile.cooldownline.y = (tonumber(SPTimers.db.profile.cooldownline.y) or 0) + buttons_move[self.i][2]
						
						self.owner.mover:ClearAllPoints()
						self.owner.mover:SetPoint("CENTER", parent, "CENTER", SPTimers.db.profile.cooldownline.x, SPTimers.db.profile.cooldownline.y)
					elseif self.owner.tip and self.owner.tip == "splash" then
						SPTimers.db.profile.cooldownline.slash_x = (tonumber(SPTimers.db.profile.cooldownline.slash_x) or 0) + buttons_move[self.i][1]
						SPTimers.db.profile.cooldownline.slash_y = (tonumber(SPTimers.db.profile.cooldownline.slash_y) or 0) + buttons_move[self.i][2]
						
						self.owner.mover:ClearAllPoints()
						self.owner.mover:SetPoint("CENTER", parent, "CENTER", SPTimers.db.profile.cooldownline.slash_x, SPTimers.db.profile.cooldownline.slash_y)
					end
					for k,v in pairs(self.owner.editboxes) do
						v:UpdateText()					
					end
				end)
			end
			
			if float then
				self.mover_add_button.buttons[5] = createbutton(self.mover_add_button, "=====")
				self.mover_add_button.buttons[5]:SetPoint("BOTTOM", self.mover_add_button, "BOTTOM", 0, 3)
				self.mover_add_button.buttons[5]:SetSize(50, 10)
				self.mover_add_button.buttons[5].owner = self.mover_add_button
				self.mover_add_button.buttons[5]:SetScript("OnClick", function(self)
					local a1,a2,a3,a4,a5 = self.owner:GetPoint()
					self.owner:ClearAllPoints()
					self.owner:SetPoint(a3,a2,a1,0, -a5)
				end)
			end
			
			for i=1,2 do				
				self.mover_add_button.editboxes[i] = createeditboxe(self.mover_add_button)
				self.mover_add_button.editboxes[i].i = i
				self.mover_add_button.editboxes[i].owner = self.mover_add_button
				
				if i == 1 then
					self.mover_add_button.editboxes[i]:SetPoint("TOPRIGHT", self.mover_add_button, "TOP", -1, -30)
				else
					self.mover_add_button.editboxes[i]:SetPoint("TOPLEFT", self.mover_add_button, "TOP", 1, -30)
				end
				
				self.mover_add_button.editboxes[i]:SetScript("OnTextChanged", function(self, user)
					if user then
						self.ok:Show()
						
						self.ok:SetScript("OnClick", self.ChangePosition)
					end
				end)
				
				self.mover_add_button.editboxes[i].ChangePosition = function(self)
					local num = tonumber(self.editbox:GetText())				
					if num then
						if self.editbox.owner.opts then
							self.editbox.owner.opts.point[self.editbox.i] = num
								
							self.editbox.owner.mover:ClearAllPoints()
							self.editbox.owner.mover:SetPoint("CENTER", parent, "CENTER", self.editbox.owner.opts.point[1], self.editbox.owner.opts.point[2])
						elseif self.editbox.owner.tip and self.editbox.owner.tip == "line" then
							
							if self.editbox.i == 1 then
								SPTimers.db.profile.cooldownline.x = num
							else
								SPTimers.db.profile.cooldownline.y = num
							end
							
							self.editbox.owner.mover:ClearAllPoints()
							self.editbox.owner.mover:SetPoint("CENTER", parent, "CENTER", SPTimers.db.profile.cooldownline.x, SPTimers.db.profile.cooldownline.y)
						elseif self.editbox.owner.tip and self.editbox.owner.tip == "splash" then
							if self.editbox.i == 1 then
								SPTimers.db.profile.cooldownline.slash_x = num
							else
								SPTimers.db.profile.cooldownline.slash_y = num
							end
							self.editbox.owner.mover:ClearAllPoints()
							self.editbox.owner.mover:SetPoint("CENTER", parent, "CENTER", SPTimers.db.profile.cooldownline.slash_x, SPTimers.db.profile.cooldownline.slash_y)
						end
					else
						self.editbox:UpdateText()
					end
					self:SetScript("OnClick", nil)
					self:Hide()
					
					self.editbox:ClearFocus()
				end
				self.mover_add_button.editboxes[i]:SetScript("OnShow", function(self) self:UpdateText() end)
				
				self.mover_add_button.editboxes[i].UpdateText = function(self)
					if self.owner.opts then
						self:SetText(tonumber(self.owner.opts.point[self.i]) or 0)
					elseif self.owner.tip and self.owner.tip == "line" then
						if self.i == 1 then
							self:SetText(tonumber(SPTimers.db.profile.cooldownline.x) or 0)
						else
							self:SetText(tonumber(SPTimers.db.profile.cooldownline.y) or 0)
						end
					elseif self.owner.tip and self.owner.tip == "splash" then
						if self.i == 1 then
							self:SetText(tonumber(SPTimers.db.profile.cooldownline.slash_x) or 0)
						else
							self:SetText(tonumber(SPTimers.db.profile.cooldownline.slash_y) or 0)
						end
					end
				end
				
				self.mover_add_button.editboxes[i]:UpdateText()
			end
		end
		self.mover_add_button.opts = opts
			
		self.mover_add_button.x = x
		self.mover_add_button.y = y
		self.mover_add_button:UpdatePoint()
	end
end
