local core = SPTimers

local libS = LibStub:GetLibrary("AceSerializer-3.0")
local AceGUI = LibStub:GetLibrary("AceGUI-3.0")
local libC = LibStub:GetLibrary("LibCompress")
local libCE = libC:GetAddonEncodeTable()
local ACD = LibStub("AceConfigDialog-3.0")

local sptimersStart = "SPTimersSTART:"
local sptimersEnd   = ":SPTimersEND"

local docompress = false

	local copy_w, copy_h = 500, 300
	
	local copyframe = CreateFrame("Frame", nil, UIParent)
	copyframe:SetPoint("CENTER")
	copyframe:SetSize(copy_w, copy_h)
	
	copyframe.Scroll = CreateFrame("ScrollFrame", "SPTimersScrollFrame", copyframe, "UIPanelScrollFrameTemplate")
	copyframe.Scroll:SetFrameLevel(copyframe:GetFrameLevel() + 1)
	copyframe.Scroll:SetSize(copy_w, copy_h)
	copyframe.Scroll:SetPoint("TOPRIGHT", copyframe, "TOPRIGHT", 0, -2)
	
	copyframe.editBox = CreateFrame("EditBox", nil, UIParent)
	copyframe.editBox:SetPoint('TOPLEFT', copyframe.Scroll, "TOPLEFT", 11, 1)
	copyframe.editBox:SetSize(copy_w, copy_h)
	
	copyframe.Scroll:SetScrollChild(copyframe.editBox)
	copyframe.Scroll:SetHorizontalScroll(-5)
	copyframe.Scroll:SetVerticalScroll(0)
	copyframe.Scroll:EnableMouse(true)
	
	copyframe.editBox:SetFont("Fonts\\ARIALN.TTF", 12, "OUTLINE")
	copyframe.editBox:SetFrameLevel(copyframe:GetFrameLevel() + 1)
	copyframe.editBox:SetAutoFocus(false)
	copyframe.editBox:SetMultiLine(true)
	copyframe.editBox:SetScript("OnEscapePressed", function(self)
		self:ClearFocus()
	end)
	copyframe:Hide()
	copyframe:SetBackdrop({
			bgFile = [=[Interface\ChatFrame\ChatFrameBackground]=],
			edgeFile = [=[Interface\ChatFrame\ChatFrameBackground]=], --[=[Interface\ChatFrame\ChatFrameBackground]=]
			edgeSize = 1,
		})
	copyframe:SetBackdropColor(0 , 0 , 0 , 0.7) -- 
	copyframe:SetBackdropBorderColor(1 , 1 , 1 , 1) -- 
	
	copyframe.button = CreateFrame("Button",nil,copyframe)
	copyframe.button:SetPoint('TOP', copyframe, 'BOTTOM', 130, -10)
	copyframe.button:SetWidth(100)
	copyframe.button:SetHeight(20)
	
	copyframe.button.fs = copyframe.button:CreateFontString()
	copyframe.button.fs:SetPoint("CENTER")
	copyframe.button.fs:SetFont("Fonts\\ARIALN.TTF", 12, "OUTLINE")
	copyframe.button.fs:SetText("Import")
	
	copyframe.button:SetNormalTexture("Interface\\Buttons\\WHITE8x8")
	copyframe.button:GetNormalTexture():SetVertexColor(0,0,0,1)
	copyframe.button:SetScript("OnClick", function(self) copyframe:Hide(); copyframe.editBox:ClearFocus(); core:DeserializeImport() end)
	copyframe.button:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8", insets = {top = -2, left = -2, bottom = -2, right = -2}})
	copyframe.button:SetBackdropColor(0, 0, 0, 1)
	copyframe.button:SetHighlightTexture("Interface\\Tooltips\\UI-Tooltip-Background")
	copyframe.button:Show()
	
	
	copyframe.button2 = CreateFrame("Button",nil,copyframe)
	copyframe.button2:SetPoint('TOP', copyframe, 'BOTTOM', -130, -10)
	copyframe.button2:SetWidth(100)
	copyframe.button2:SetHeight(20)
	
	copyframe.button2.fs = copyframe.button2:CreateFontString()
	copyframe.button2.fs:SetPoint("CENTER")
	copyframe.button2.fs:SetFont("Fonts\\ARIALN.TTF", 12, "OUTLINE")
	copyframe.button2.fs:SetText("Select All")
	
	copyframe.button2:SetNormalTexture("Interface\\Buttons\\WHITE8x8")
	copyframe.button2:GetNormalTexture():SetVertexColor(0,0,0,1)
	copyframe.button2:SetScript("OnClick", function(self) copyframe.editBox:HighlightText(0) end)
	copyframe.button2:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8", insets = {top = -2, left = -2, bottom = -2, right = -2}})
	copyframe.button2:SetBackdropColor(0, 0, 0, 1)
	copyframe.button2:SetHighlightTexture("Interface\\Tooltips\\UI-Tooltip-Background")
	copyframe.button2:Show()
	
	copyframe.button3 = CreateFrame("Button",nil,copyframe)
	copyframe.button3:SetPoint('TOP', copyframe, 'BOTTOM', 0, -10)
	copyframe.button3:SetWidth(100)
	copyframe.button3:SetHeight(20)
	
	copyframe.button3.fs = copyframe.button3:CreateFontString()
	copyframe.button3.fs:SetPoint("CENTER")
	copyframe.button3.fs:SetFont("Fonts\\ARIALN.TTF", 12, "OUTLINE")
	copyframe.button3.fs:SetText("Close")
	
	copyframe.button3:SetNormalTexture("Interface\\Buttons\\WHITE8x8")
	copyframe.button3:GetNormalTexture():SetVertexColor(0,0,0,1)
	copyframe.button3:SetScript("OnClick", function(self) copyframe:Hide(); copyframe.editBox:ClearFocus(); ACD:Open("SPTimers") end)
	copyframe.button3:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8", insets = {top = -2, left = -2, bottom = -2, right = -2}})
	copyframe.button3:SetBackdropColor(0, 0, 0, 1)
	copyframe.button3:SetHighlightTexture("Interface\\Tooltips\\UI-Tooltip-Background")
	copyframe.button3:Show()

	
function core:ExportProfile()
	local data1
	
	if docompress then
	
		local data3 = libS:Serialize(self.db.profile)
		
		local data2 = libC:Compress(data3)
		
		data1 = libCE:Encode(data2)
	
	
	else
	
		data1 = libS:Serialize(self.db.profile)
	end
	
	copyframe:Show()

	ACD:Close("SPTimers")
	
	copyframe.editBox:SetText(data1)
	
	copyframe.editBox:HighlightText(0)
	
	copyframe.editBox:SetFocus()
	
	copyframe.button3:Show()
	copyframe.button2:Show()
	copyframe.button:Hide()
end
local function deepcopy(t)
		if type(t) ~= 'table' then return t end
			local mt = getmetatable(t)
			local res = {}
			for k,v in pairs(t) do
				if type(v) == 'table' then
					v = deepcopy(v)
				end
			res[k] = v
			end
			setmetatable(res,mt)
		return res
	end
	
function core:DeserializeImport()
	
	local final_d = nil
	
	if docompress then
	
		local data3 = copyframe.editBox:GetText()
		
		local data2 = libCE:Decode(data3)

		local data1, message = libC:Decompress(data2)
		
		
		if(not data1) then
			print("YourAddon: error decompressing: " .. message)
			return
		end
		
		local done, final = libS:Deserialize(data1)
		if (not done) then
			print("YourAddon: error deserializing " .. final)
			return
		end
		
		final_d = final
	else
		local data3 = copyframe.editBox:GetText()
		
		
		local done, final = libS:Deserialize(data3)
		if (not done) then
			print("YourAddon: error deserializing " .. final)
			return
		end
		
		final_d = final
	end
	
	if ( final_d ) then
		local gentime = date("%H:%M:%S %a%b%d")

		final_d.classCooldowns = nil

		for name,datas in pairs(final_d.internal_cooldowns) do		
			if datas.spellid then				
				if GetSpellInfo(datas.spellid) == nil or GetSpellInfo(datas.spellid) == "" then					
					final_d.internal_cooldowns[name] = nil					
				else					
					if GetSpellInfo(datas.spellid) ~= name then									
						final_d.internal_cooldowns[GetSpellInfo(datas.spellid)] = deepcopy(datas)					
						final_d.internal_cooldowns[name] = nil
					end
				end
			else
				final_d.internal_cooldowns[name] = nil
			end
		end
		
		for name,datas in pairs(final_d.cooldownline.block) do		
			if datas.spellid then				
				if GetSpellInfo(datas.spellid) == nil or GetSpellInfo(datas.spellid) == "" then					
					final_d.cooldownline.block[name] = nil					
				else					
					if GetSpellInfo(datas.spellid) ~= name then									
						final_d.cooldownline.block[GetSpellInfo(datas.spellid)] = deepcopy(datas)					
						final_d.cooldownline.block[name] = nil
					end
				end
			elseif datas.itemid then
				if GetItemInfo(datas.spellid) == nil or GetItemInfo(datas.itemid) == "" then					
					final_d.cooldownline.block[name] = nil					
				else					
					if GetItemInfo(datas.itemid) ~= name then									
						final_d.cooldownline.block[GetItemInfo(datas.itemid)] = deepcopy(datas)					
						final_d.cooldownline.block[name] = nil
					end
				end				
			else
				final_d.cooldownline.block[name] = nil
			end
		end
		
		for class, datas in pairs(final_d.classCooldowns) do
			
			for name,datas2 in pairs(datas) do
				
				if datas2.spellid then
					if GetSpellInfo(datas2.spellid) == nil or GetSpellInfo(datas2.spellid) == "" then					
						final_d.classCooldowns[class][name] = nil					
					else					
						if GetSpellInfo(datas2.spellid) ~= name then									
							final_d.classCooldowns[class][GetSpellInfo(datas2.spellid)] = deepcopy(datas)					
							final_d.classCooldowns[class][name] = nil
						end
					end
				else
					final_d.classCooldowns[class][name] = nil
				end
			end
		end
		
		
		for k,v in pairs(final_d.procSpells) do
			if GetSpellInfo(k) == nil or GetSpellInfo(k) == "" then
				print("Wrong procSpells spellID", k)		
				final_d.procSpells[k] = nil
			end
		end
		
		for k,v in pairs(final_d.othersSpells) do
			if GetSpellInfo(k) == nil or GetSpellInfo(k) == "" then
				print("Wrong othersSpells spellID", k)			
				final_d.othersSpells[k] = nil
			end
		end
		
		for class, datas in pairs(final_d.classSpells) do
			
			for i, val in pairs(datas) do
				if GetSpellInfo(i) == nil or GetSpellInfo(i) == "" then
					print("Wrong classSpells spellID", i)			

					final_d.classSpells[class][i] = nil
				end				
			end
		end
	
		self.message('Imported to "Import - '..gentime)
		
		SPTimersDB.profiles["Import - "..gentime] = deepcopy(final_d)
	end
	
	ACD:Open("SPTimers")
end

function core:ImportProfile(str)
	
	copyframe.editBox:SetText("")
	copyframe:Show()
	copyframe.editBox:SetFocus()
	
	ACD:Close("SPTimers")
	
	copyframe.button3:Show()
	copyframe.button2:Hide()
	copyframe.button:Show()
end



-- ... add your widgets to "scroll"